/*
 * Copyright (c) Contributors, http://opensimulator.org/
 * See CONTRIBUTORS.TXT for a full list of copyright holders.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the OpenSim Project nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

using System;using Tools;
namespace OpenSim.Region.ScriptEngine.Shared.CodeTools {
//%+STRING_CONSTANT+3
public class STRING_CONSTANT : TOKEN{
public override string yyname { get { return "STRING_CONSTANT"; }}
public override int yynum { get { return 3; }}
public STRING_CONSTANT(Lexer yyl):base(yyl){}}
//%INCREMENT+4
public class INCREMENT : TOKEN{ public override string yyname { get { return "INCREMENT";}}
public override int yynum { get { return 4; }}
 public INCREMENT(Lexer yyl):base(yyl) {}}
//%DECREMENT+5
public class DECREMENT : TOKEN{ public override string yyname { get { return "DECREMENT";}}
public override int yynum { get { return 5; }}
 public DECREMENT(Lexer yyl):base(yyl) {}}
//%PLUS_EQUALS+6
public class PLUS_EQUALS : TOKEN{ public override string yyname { get { return "PLUS_EQUALS";}}
public override int yynum { get { return 6; }}
 public PLUS_EQUALS(Lexer yyl):base(yyl) {}}
//%MINUS_EQUALS+7
public class MINUS_EQUALS : TOKEN{ public override string yyname { get { return "MINUS_EQUALS";}}
public override int yynum { get { return 7; }}
 public MINUS_EQUALS(Lexer yyl):base(yyl) {}}
//%STAR_EQUALS+8
public class STAR_EQUALS : TOKEN{ public override string yyname { get { return "STAR_EQUALS";}}
public override int yynum { get { return 8; }}
 public STAR_EQUALS(Lexer yyl):base(yyl) {}}
//%SLASH_EQUALS+9
public class SLASH_EQUALS : TOKEN{ public override string yyname { get { return "SLASH_EQUALS";}}
public override int yynum { get { return 9; }}
 public SLASH_EQUALS(Lexer yyl):base(yyl) {}}
//%PERCENT_EQUALS+10
public class PERCENT_EQUALS : TOKEN{ public override string yyname { get { return "PERCENT_EQUALS";}}
public override int yynum { get { return 10; }}
 public PERCENT_EQUALS(Lexer yyl):base(yyl) {}}
//%SEMICOLON+11
public class SEMICOLON : TOKEN{ public override string yyname { get { return "SEMICOLON";}}
public override int yynum { get { return 11; }}
 public SEMICOLON(Lexer yyl):base(yyl) {}}
//%LEFT_BRACE+12
public class LEFT_BRACE : TOKEN{ public override string yyname { get { return "LEFT_BRACE";}}
public override int yynum { get { return 12; }}
 public LEFT_BRACE(Lexer yyl):base(yyl) {}}
//%RIGHT_BRACE+13
public class RIGHT_BRACE : TOKEN{ public override string yyname { get { return "RIGHT_BRACE";}}
public override int yynum { get { return 13; }}
 public RIGHT_BRACE(Lexer yyl):base(yyl) {}}
//%COMMA+14
public class COMMA : TOKEN{ public override string yyname { get { return "COMMA";}}
public override int yynum { get { return 14; }}
 public COMMA(Lexer yyl):base(yyl) {}}
//%EQUALS+15
public class EQUALS : TOKEN{ public override string yyname { get { return "EQUALS";}}
public override int yynum { get { return 15; }}
 public EQUALS(Lexer yyl):base(yyl) {}}
//%LEFT_PAREN+16
public class LEFT_PAREN : TOKEN{ public override string yyname { get { return "LEFT_PAREN";}}
public override int yynum { get { return 16; }}
 public LEFT_PAREN(Lexer yyl):base(yyl) {}}
//%RIGHT_PAREN+17
public class RIGHT_PAREN : TOKEN{ public override string yyname { get { return "RIGHT_PAREN";}}
public override int yynum { get { return 17; }}
 public RIGHT_PAREN(Lexer yyl):base(yyl) {}}
//%PLUS+18
public class PLUS : TOKEN{ public override string yyname { get { return "PLUS";}}
public override int yynum { get { return 18; }}
 public PLUS(Lexer yyl):base(yyl) {}}
//%MINUS+19
public class MINUS : TOKEN{ public override string yyname { get { return "MINUS";}}
public override int yynum { get { return 19; }}
 public MINUS(Lexer yyl):base(yyl) {}}
//%STAR+20
public class STAR : TOKEN{ public override string yyname { get { return "STAR";}}
public override int yynum { get { return 20; }}
 public STAR(Lexer yyl):base(yyl) {}}
//%SLASH+21
public class SLASH : TOKEN{ public override string yyname { get { return "SLASH";}}
public override int yynum { get { return 21; }}
 public SLASH(Lexer yyl):base(yyl) {}}
//%PERCENT+22
public class PERCENT : TOKEN{ public override string yyname { get { return "PERCENT";}}
public override int yynum { get { return 22; }}
 public PERCENT(Lexer yyl):base(yyl) {}}
//%AT+23
public class AT : TOKEN{ public override string yyname { get { return "AT";}}
public override int yynum { get { return 23; }}
 public AT(Lexer yyl):base(yyl) {}}
//%PERIOD+24
public class PERIOD : TOKEN{ public override string yyname { get { return "PERIOD";}}
public override int yynum { get { return 24; }}
 public PERIOD(Lexer yyl):base(yyl) {}}
//%LEFT_ANGLE+25
public class LEFT_ANGLE : TOKEN{ public override string yyname { get { return "LEFT_ANGLE";}}
public override int yynum { get { return 25; }}
 public LEFT_ANGLE(Lexer yyl):base(yyl) {}}
//%RIGHT_ANGLE+26
public class RIGHT_ANGLE : TOKEN{ public override string yyname { get { return "RIGHT_ANGLE";}}
public override int yynum { get { return 26; }}
 public RIGHT_ANGLE(Lexer yyl):base(yyl) {}}
//%LEFT_BRACKET+27
public class LEFT_BRACKET : TOKEN{ public override string yyname { get { return "LEFT_BRACKET";}}
public override int yynum { get { return 27; }}
 public LEFT_BRACKET(Lexer yyl):base(yyl) {}}
//%RIGHT_BRACKET+28
public class RIGHT_BRACKET : TOKEN{ public override string yyname { get { return "RIGHT_BRACKET";}}
public override int yynum { get { return 28; }}
 public RIGHT_BRACKET(Lexer yyl):base(yyl) {}}
//%EQUALS_EQUALS+29
public class EQUALS_EQUALS : TOKEN{ public override string yyname { get { return "EQUALS_EQUALS";}}
public override int yynum { get { return 29; }}
 public EQUALS_EQUALS(Lexer yyl):base(yyl) {}}
//%EXCLAMATION_EQUALS+30
public class EXCLAMATION_EQUALS : TOKEN{ public override string yyname { get { return "EXCLAMATION_EQUALS";}}
public override int yynum { get { return 30; }}
 public EXCLAMATION_EQUALS(Lexer yyl):base(yyl) {}}
//%LESS_EQUALS+31
public class LESS_EQUALS : TOKEN{ public override string yyname { get { return "LESS_EQUALS";}}
public override int yynum { get { return 31; }}
 public LESS_EQUALS(Lexer yyl):base(yyl) {}}
//%GREATER_EQUALS+32
public class GREATER_EQUALS : TOKEN{ public override string yyname { get { return "GREATER_EQUALS";}}
public override int yynum { get { return 32; }}
 public GREATER_EQUALS(Lexer yyl):base(yyl) {}}
//%AMP+33
public class AMP : TOKEN{ public override string yyname { get { return "AMP";}}
public override int yynum { get { return 33; }}
 public AMP(Lexer yyl):base(yyl) {}}
//%STROKE+34
public class STROKE : TOKEN{ public override string yyname { get { return "STROKE";}}
public override int yynum { get { return 34; }}
 public STROKE(Lexer yyl):base(yyl) {}}
//%CARET+35
public class CARET : TOKEN{ public override string yyname { get { return "CARET";}}
public override int yynum { get { return 35; }}
 public CARET(Lexer yyl):base(yyl) {}}
//%TILDE+36
public class TILDE : TOKEN{ public override string yyname { get { return "TILDE";}}
public override int yynum { get { return 36; }}
 public TILDE(Lexer yyl):base(yyl) {}}
//%EXCLAMATION+37
public class EXCLAMATION : TOKEN{ public override string yyname { get { return "EXCLAMATION";}}
public override int yynum { get { return 37; }}
 public EXCLAMATION(Lexer yyl):base(yyl) {}}
//%AMP_AMP+38
public class AMP_AMP : TOKEN{ public override string yyname { get { return "AMP_AMP";}}
public override int yynum { get { return 38; }}
 public AMP_AMP(Lexer yyl):base(yyl) {}}
//%STROKE_STROKE+39
public class STROKE_STROKE : TOKEN{ public override string yyname { get { return "STROKE_STROKE";}}
public override int yynum { get { return 39; }}
 public STROKE_STROKE(Lexer yyl):base(yyl) {}}
//%LEFT_SHIFT+40
public class LEFT_SHIFT : TOKEN{ public override string yyname { get { return "LEFT_SHIFT";}}
public override int yynum { get { return 40; }}
 public LEFT_SHIFT(Lexer yyl):base(yyl) {}}
//%RIGHT_SHIFT+41
public class RIGHT_SHIFT : TOKEN{ public override string yyname { get { return "RIGHT_SHIFT";}}
public override int yynum { get { return 41; }}
 public RIGHT_SHIFT(Lexer yyl):base(yyl) {}}
//%IF+42
public class IF : TOKEN{ public override string yyname { get { return "IF";}}
public override int yynum { get { return 42; }}
 public IF(Lexer yyl):base(yyl) {}}
//%ELSE+43
public class ELSE : TOKEN{ public override string yyname { get { return "ELSE";}}
public override int yynum { get { return 43; }}
 public ELSE(Lexer yyl):base(yyl) {}}
//%DO+44
public class DO : TOKEN{ public override string yyname { get { return "DO";}}
public override int yynum { get { return 44; }}
 public DO(Lexer yyl):base(yyl) {}}
//%WHILE+45
public class WHILE : TOKEN{ public override string yyname { get { return "WHILE";}}
public override int yynum { get { return 45; }}
 public WHILE(Lexer yyl):base(yyl) {}}
//%FOR+46
public class FOR : TOKEN{ public override string yyname { get { return "FOR";}}
public override int yynum { get { return 46; }}
 public FOR(Lexer yyl):base(yyl) {}}
//%DEFAULT_STATE+47
public class DEFAULT_STATE : TOKEN{ public override string yyname { get { return "DEFAULT_STATE";}}
public override int yynum { get { return 47; }}
 public DEFAULT_STATE(Lexer yyl):base(yyl) {}}
//%STATE+48
public class STATE : TOKEN{ public override string yyname { get { return "STATE";}}
public override int yynum { get { return 48; }}
 public STATE(Lexer yyl):base(yyl) {}}
//%JUMP+49
public class JUMP : TOKEN{ public override string yyname { get { return "JUMP";}}
public override int yynum { get { return 49; }}
 public JUMP(Lexer yyl):base(yyl) {}}
//%RETURN+50
public class RETURN : TOKEN{ public override string yyname { get { return "RETURN";}}
public override int yynum { get { return 50; }}
 public RETURN(Lexer yyl):base(yyl) {}}
//%INTEGER_TYPE+51
public class INTEGER_TYPE : TOKEN{ public override string yyname { get { return "INTEGER_TYPE";}}
public override int yynum { get { return 51; }}
 public INTEGER_TYPE(Lexer yyl):base(yyl) {}}
//%FLOAT_TYPE+52
public class FLOAT_TYPE : TOKEN{ public override string yyname { get { return "FLOAT_TYPE";}}
public override int yynum { get { return 52; }}
 public FLOAT_TYPE(Lexer yyl):base(yyl) {}}
//%STRING_TYPE+53
public class STRING_TYPE : TOKEN{ public override string yyname { get { return "STRING_TYPE";}}
public override int yynum { get { return 53; }}
 public STRING_TYPE(Lexer yyl):base(yyl) {}}
//%KEY_TYPE+54
public class KEY_TYPE : TOKEN{ public override string yyname { get { return "KEY_TYPE";}}
public override int yynum { get { return 54; }}
 public KEY_TYPE(Lexer yyl):base(yyl) {}}
//%VECTOR_TYPE+55
public class VECTOR_TYPE : TOKEN{ public override string yyname { get { return "VECTOR_TYPE";}}
public override int yynum { get { return 55; }}
 public VECTOR_TYPE(Lexer yyl):base(yyl) {}}
//%ROTATION_TYPE+56
public class ROTATION_TYPE : TOKEN{ public override string yyname { get { return "ROTATION_TYPE";}}
public override int yynum { get { return 56; }}
 public ROTATION_TYPE(Lexer yyl):base(yyl) {}}
//%LIST_TYPE+57
public class LIST_TYPE : TOKEN{ public override string yyname { get { return "LIST_TYPE";}}
public override int yynum { get { return 57; }}
 public LIST_TYPE(Lexer yyl):base(yyl) {}}
//%AT_ROT_TARGET_EVENT+58
public class AT_ROT_TARGET_EVENT : TOKEN{ public override string yyname { get { return "AT_ROT_TARGET_EVENT";}}
public override int yynum { get { return 58; }}
 public AT_ROT_TARGET_EVENT(Lexer yyl):base(yyl) {}}
//%AT_TARGET_EVENT+59
public class AT_TARGET_EVENT : TOKEN{ public override string yyname { get { return "AT_TARGET_EVENT";}}
public override int yynum { get { return 59; }}
 public AT_TARGET_EVENT(Lexer yyl):base(yyl) {}}
//%ATTACH_EVENT+60
public class ATTACH_EVENT : TOKEN{ public override string yyname { get { return "ATTACH_EVENT";}}
public override int yynum { get { return 60; }}
 public ATTACH_EVENT(Lexer yyl):base(yyl) {}}
//%CHANGED_EVENT+61
public class CHANGED_EVENT : TOKEN{ public override string yyname { get { return "CHANGED_EVENT";}}
public override int yynum { get { return 61; }}
 public CHANGED_EVENT(Lexer yyl):base(yyl) {}}
//%COLLISION_EVENT+62
public class COLLISION_EVENT : TOKEN{ public override string yyname { get { return "COLLISION_EVENT";}}
public override int yynum { get { return 62; }}
 public COLLISION_EVENT(Lexer yyl):base(yyl) {}}
//%COLLISION_END_EVENT+63
public class COLLISION_END_EVENT : TOKEN{ public override string yyname { get { return "COLLISION_END_EVENT";}}
public override int yynum { get { return 63; }}
 public COLLISION_END_EVENT(Lexer yyl):base(yyl) {}}
//%COLLISION_START_EVENT+64
public class COLLISION_START_EVENT : TOKEN{ public override string yyname { get { return "COLLISION_START_EVENT";}}
public override int yynum { get { return 64; }}
 public COLLISION_START_EVENT(Lexer yyl):base(yyl) {}}
//%CONTROL_EVENT+65
public class CONTROL_EVENT : TOKEN{ public override string yyname { get { return "CONTROL_EVENT";}}
public override int yynum { get { return 65; }}
 public CONTROL_EVENT(Lexer yyl):base(yyl) {}}
//%DATASERVER_EVENT+66
public class DATASERVER_EVENT : TOKEN{ public override string yyname { get { return "DATASERVER_EVENT";}}
public override int yynum { get { return 66; }}
 public DATASERVER_EVENT(Lexer yyl):base(yyl) {}}
//%EMAIL_EVENT+67
public class EMAIL_EVENT : TOKEN{ public override string yyname { get { return "EMAIL_EVENT";}}
public override int yynum { get { return 67; }}
 public EMAIL_EVENT(Lexer yyl):base(yyl) {}}
//%HTTP_RESPONSE_EVENT+68
public class HTTP_RESPONSE_EVENT : TOKEN{ public override string yyname { get { return "HTTP_RESPONSE_EVENT";}}
public override int yynum { get { return 68; }}
 public HTTP_RESPONSE_EVENT(Lexer yyl):base(yyl) {}}
//%LAND_COLLISION_EVENT+69
public class LAND_COLLISION_EVENT : TOKEN{ public override string yyname { get { return "LAND_COLLISION_EVENT";}}
public override int yynum { get { return 69; }}
 public LAND_COLLISION_EVENT(Lexer yyl):base(yyl) {}}
//%LAND_COLLISION_END_EVENT+70
public class LAND_COLLISION_END_EVENT : TOKEN{ public override string yyname { get { return "LAND_COLLISION_END_EVENT";}}
public override int yynum { get { return 70; }}
 public LAND_COLLISION_END_EVENT(Lexer yyl):base(yyl) {}}
//%LAND_COLLISION_START_EVENT+71
public class LAND_COLLISION_START_EVENT : TOKEN{ public override string yyname { get { return "LAND_COLLISION_START_EVENT";}}
public override int yynum { get { return 71; }}
 public LAND_COLLISION_START_EVENT(Lexer yyl):base(yyl) {}}
//%LINK_MESSAGE_EVENT+72
public class LINK_MESSAGE_EVENT : TOKEN{ public override string yyname { get { return "LINK_MESSAGE_EVENT";}}
public override int yynum { get { return 72; }}
 public LINK_MESSAGE_EVENT(Lexer yyl):base(yyl) {}}
//%LISTEN_EVENT+73
public class LISTEN_EVENT : TOKEN{ public override string yyname { get { return "LISTEN_EVENT";}}
public override int yynum { get { return 73; }}
 public LISTEN_EVENT(Lexer yyl):base(yyl) {}}
//%MONEY_EVENT+74
public class MONEY_EVENT : TOKEN{ public override string yyname { get { return "MONEY_EVENT";}}
public override int yynum { get { return 74; }}
 public MONEY_EVENT(Lexer yyl):base(yyl) {}}
//%MOVING_END_EVENT+75
public class MOVING_END_EVENT : TOKEN{ public override string yyname { get { return "MOVING_END_EVENT";}}
public override int yynum { get { return 75; }}
 public MOVING_END_EVENT(Lexer yyl):base(yyl) {}}
//%MOVING_START_EVENT+76
public class MOVING_START_EVENT : TOKEN{ public override string yyname { get { return "MOVING_START_EVENT";}}
public override int yynum { get { return 76; }}
 public MOVING_START_EVENT(Lexer yyl):base(yyl) {}}
//%NO_SENSOR_EVENT+77
public class NO_SENSOR_EVENT : TOKEN{ public override string yyname { get { return "NO_SENSOR_EVENT";}}
public override int yynum { get { return 77; }}
 public NO_SENSOR_EVENT(Lexer yyl):base(yyl) {}}
//%NOT_AT_ROT_TARGET_EVENT+78
public class NOT_AT_ROT_TARGET_EVENT : TOKEN{ public override string yyname { get { return "NOT_AT_ROT_TARGET_EVENT";}}
public override int yynum { get { return 78; }}
 public NOT_AT_ROT_TARGET_EVENT(Lexer yyl):base(yyl) {}}
//%NOT_AT_TARGET_EVENT+79
public class NOT_AT_TARGET_EVENT : TOKEN{ public override string yyname { get { return "NOT_AT_TARGET_EVENT";}}
public override int yynum { get { return 79; }}
 public NOT_AT_TARGET_EVENT(Lexer yyl):base(yyl) {}}
//%OBJECT_REZ_EVENT+80
public class OBJECT_REZ_EVENT : TOKEN{ public override string yyname { get { return "OBJECT_REZ_EVENT";}}
public override int yynum { get { return 80; }}
 public OBJECT_REZ_EVENT(Lexer yyl):base(yyl) {}}
//%ON_REZ_EVENT+81
public class ON_REZ_EVENT : TOKEN{ public override string yyname { get { return "ON_REZ_EVENT";}}
public override int yynum { get { return 81; }}
 public ON_REZ_EVENT(Lexer yyl):base(yyl) {}}
//%REMOTE_DATA_EVENT+82
public class REMOTE_DATA_EVENT : TOKEN{ public override string yyname { get { return "REMOTE_DATA_EVENT";}}
public override int yynum { get { return 82; }}
 public REMOTE_DATA_EVENT(Lexer yyl):base(yyl) {}}
//%RUN_TIME_PERMISSIONS_EVENT+83
public class RUN_TIME_PERMISSIONS_EVENT : TOKEN{ public override string yyname { get { return "RUN_TIME_PERMISSIONS_EVENT";}}
public override int yynum { get { return 83; }}
 public RUN_TIME_PERMISSIONS_EVENT(Lexer yyl):base(yyl) {}}
//%SENSOR_EVENT+84
public class SENSOR_EVENT : TOKEN{ public override string yyname { get { return "SENSOR_EVENT";}}
public override int yynum { get { return 84; }}
 public SENSOR_EVENT(Lexer yyl):base(yyl) {}}
//%STATE_ENTRY_EVENT+85
public class STATE_ENTRY_EVENT : TOKEN{ public override string yyname { get { return "STATE_ENTRY_EVENT";}}
public override int yynum { get { return 85; }}
 public STATE_ENTRY_EVENT(Lexer yyl):base(yyl) {}}
//%STATE_EXIT_EVENT+86
public class STATE_EXIT_EVENT : TOKEN{ public override string yyname { get { return "STATE_EXIT_EVENT";}}
public override int yynum { get { return 86; }}
 public STATE_EXIT_EVENT(Lexer yyl):base(yyl) {}}
//%TIMER_EVENT+87
public class TIMER_EVENT : TOKEN{ public override string yyname { get { return "TIMER_EVENT";}}
public override int yynum { get { return 87; }}
 public TIMER_EVENT(Lexer yyl):base(yyl) {}}
//%TOUCH_EVENT+88
public class TOUCH_EVENT : TOKEN{ public override string yyname { get { return "TOUCH_EVENT";}}
public override int yynum { get { return 88; }}
 public TOUCH_EVENT(Lexer yyl):base(yyl) {}}
//%TOUCH_START_EVENT+89
public class TOUCH_START_EVENT : TOKEN{ public override string yyname { get { return "TOUCH_START_EVENT";}}
public override int yynum { get { return 89; }}
 public TOUCH_START_EVENT(Lexer yyl):base(yyl) {}}
//%TOUCH_END_EVENT+90
public class TOUCH_END_EVENT : TOKEN{ public override string yyname { get { return "TOUCH_END_EVENT";}}
public override int yynum { get { return 90; }}
 public TOUCH_END_EVENT(Lexer yyl):base(yyl) {}}
//%IDENT+91
public class IDENT : TOKEN{ public override string yyname { get { return "IDENT";}}
public override int yynum { get { return 91; }}
 public IDENT(Lexer yyl):base(yyl) {}}
//%INTEGER_CONSTANT+92
public class INTEGER_CONSTANT : TOKEN{ public override string yyname { get { return "INTEGER_CONSTANT";}}
public override int yynum { get { return 92; }}
 public INTEGER_CONSTANT(Lexer yyl):base(yyl) {}}
//%HEX_INTEGER_CONSTANT+93
public class HEX_INTEGER_CONSTANT : TOKEN{ public override string yyname { get { return "HEX_INTEGER_CONSTANT";}}
public override int yynum { get { return 93; }}
 public HEX_INTEGER_CONSTANT(Lexer yyl):base(yyl) {}}
//%FLOAT_CONSTANT+94
public class FLOAT_CONSTANT : TOKEN{ public override string yyname { get { return "FLOAT_CONSTANT";}}
public override int yynum { get { return 94; }}
 public FLOAT_CONSTANT(Lexer yyl):base(yyl) {}}
//%|LSLTokens
public class yyLSLTokens : YyLexer {
 public yyLSLTokens(ErrorHandler eh):base(eh) { arr = new int[] { 
101,4,6,52,0,
46,0,53,0,6,
102,4,16,117,0,
115,0,45,0,97,
0,115,0,99,0,
105,0,105,0,2,
0,103,5,27,7,
0,104,9,1,0,
3,192,0,105,5,
27,3,65,0,2,
1,3,66,0,2,
1,3,67,0,2,
1,3,68,0,2,
1,3,69,0,2,
1,3,70,0,2,
1,3,71,0,2,
1,3,72,0,2,
1,3,73,0,2,
1,3,74,0,2,
1,3,75,0,2,
1,3,76,0,2,
1,3,77,0,2,
1,3,78,0,2,
1,3,79,0,2,
1,3,80,0,2,
1,3,81,0,2,
1,3,82,0,2,
1,3,83,0,2,
1,3,84,0,2,
1,3,85,0,2,
1,3,86,0,2,
1,3,87,0,2,
1,3,88,0,2,
1,3,89,0,2,
1,3,90,0,2,
1,3,192,0,2,
1,7,1,106,9,
1,1,3,170,0,
107,5,27,3,109,
0,2,1,3,110,
0,2,1,3,111,
0,2,1,3,112,
0,2,1,3,113,
0,2,1,3,114,
0,2,1,3,115,
0,2,1,3,116,
0,2,1,3,117,
0,2,1,3,118,
0,2,1,3,119,
0,2,1,3,120,
0,2,1,3,121,
0,2,1,3,122,
0,2,1,3,170,
0,2,1,3,97,
0,2,1,3,98,
0,2,1,3,99,
0,2,1,3,100,
0,2,1,3,101,
0,2,1,3,102,
0,2,1,3,103,
0,2,1,3,104,
0,2,1,3,105,
0,2,1,3,106,
0,2,1,3,107,
0,2,1,3,108,
0,2,1,7,2,
108,9,1,2,3,
197,1,109,5,1,
3,197,1,2,1,
7,3,110,9,1,
3,3,176,2,111,
5,1,3,176,2,
2,1,7,4,112,
9,1,4,3,187,
1,113,5,1,3,
187,1,2,1,7,
5,114,9,1,5,
3,0,3,115,5,
1,3,0,3,2,
1,7,6,116,9,
1,6,3,3,9,
117,5,1,3,3,
9,2,1,7,7,
118,9,1,7,3,
136,4,119,5,1,
3,136,4,2,1,
7,8,120,9,1,
8,3,96,6,121,
5,11,3,96,6,
2,1,3,48,0,
2,1,3,49,0,
2,1,3,50,0,
2,1,3,51,0,
2,1,3,52,0,
2,1,3,53,0,
2,1,3,54,0,
2,1,3,55,0,
2,1,3,56,0,
2,1,3,57,0,
2,1,7,9,122,
9,1,9,3,96,
33,123,5,1,3,
96,33,2,1,7,
10,124,9,1,10,
3,178,0,125,5,
1,3,178,0,2,
1,7,11,126,9,
1,11,3,160,0,
127,5,2,3,160,
0,2,1,3,32,
0,2,1,7,12,
128,9,1,12,3,
40,32,129,5,1,
3,40,32,2,1,
7,13,130,9,1,
13,3,41,32,131,
5,1,3,41,32,
2,1,7,14,132,
9,1,14,3,1,
0,133,5,5,3,
0,0,2,1,3,
1,0,2,1,3,
13,0,2,1,3,
9,0,2,1,3,
10,0,2,1,7,
15,134,9,1,15,
3,15,7,135,5,
1,3,15,7,2,
1,7,17,136,9,
1,17,3,0,224,
137,5,1,3,0,
224,2,1,7,18,
138,9,1,18,3,
63,32,139,5,2,
3,63,32,2,1,
3,95,0,2,1,
7,19,140,9,1,
19,3,173,0,141,
5,2,3,45,0,
2,1,3,173,0,
2,1,7,20,142,
9,1,20,3,58,
15,143,5,4,3,
123,0,2,1,3,
91,0,2,1,3,
58,15,2,1,3,
40,0,2,1,7,
21,144,9,1,21,
3,59,15,145,5,
4,3,59,15,2,
1,3,125,0,2,
1,3,93,0,2,
1,3,41,0,2,
1,7,22,146,9,
1,22,3,171,0,
147,5,1,3,171,
0,2,1,7,23,
148,9,1,23,3,
187,0,149,5,1,
3,187,0,2,1,
7,24,150,9,1,
24,3,35,0,151,
5,12,3,37,0,
2,1,3,38,0,
2,1,3,42,0,
2,1,3,44,0,
2,1,3,46,0,
2,1,3,47,0,
2,1,3,92,0,
2,1,3,59,0,
2,1,3,64,0,
2,1,3,33,0,
2,1,3,34,0,
2,1,3,35,0,
2,1,7,25,152,
9,1,25,3,172,
0,153,5,7,3,
172,0,2,1,3,
124,0,2,1,3,
126,0,2,1,3,
60,0,2,1,3,
61,0,2,1,3,
62,0,2,1,3,
43,0,2,1,7,
26,154,9,1,26,
3,36,0,155,5,
1,3,36,0,2,
1,7,27,156,9,
1,27,3,96,0,
157,5,2,3,94,
0,2,1,3,96,
0,2,1,7,27,
2,0,158,5,2,
159,4,18,89,0,
89,0,73,0,78,
0,73,0,84,0,
73,0,65,0,76,
0,160,12,1,1022,
161,5,91,3,9,
0,162,12,1,39257,
163,5,0,164,11,
1,999,0,165,4,
0,1,-1,3,10,
0,162,3,13,0,
162,3,32,0,162,
3,33,0,166,12,
1,42170,167,5,1,
3,61,0,168,12,
1,42285,169,5,0,
170,11,1,142,0,
171,4,36,69,0,
88,0,67,0,76,
0,65,0,77,0,
65,0,84,0,73,
0,79,0,78,0,
95,0,69,0,81,
0,85,0,65,0,
76,0,83,0,1,
-1,172,11,1,180,
0,173,4,22,69,
0,88,0,67,0,
76,0,65,0,77,
0,65,0,84,0,
73,0,79,0,78,
0,1,-1,3,34,
0,174,12,1,42411,
175,5,0,176,11,
1,925,0,165,1,
-1,3,37,0,177,
12,1,40481,178,5,
1,3,61,0,179,
12,1,40596,180,5,
0,181,11,1,40,
0,182,4,28,80,
0,69,0,82,0,
67,0,69,0,78,
0,84,0,95,0,
69,0,81,0,85,
0,65,0,76,0,
83,0,1,-1,183,
11,1,101,0,184,
4,14,80,0,69,
0,82,0,67,0,
69,0,78,0,84,
0,1,-1,3,38,
0,185,12,1,40722,
186,5,1,3,38,
0,187,12,1,40822,
188,5,0,189,11,
1,185,0,190,4,
14,65,0,77,0,
80,0,95,0,65,
0,77,0,80,0,
1,-1,191,11,1,
160,0,192,4,6,
65,0,77,0,80,
0,1,-1,3,40,
0,193,12,1,39994,
194,5,0,195,11,
1,71,0,196,4,
20,76,0,69,0,
70,0,84,0,95,
0,80,0,65,0,
82,0,69,0,78,
0,1,-1,3,41,
0,197,12,1,40358,
198,5,0,199,11,
1,76,0,200,4,
22,82,0,73,0,
71,0,72,0,84,
0,95,0,80,0,
65,0,82,0,69,
0,78,0,1,-1,
3,42,0,201,12,
1,40963,202,5,1,
3,61,0,203,12,
1,41078,204,5,0,
205,11,1,28,0,
206,4,22,83,0,
84,0,65,0,82,
0,95,0,69,0,
81,0,85,0,65,
0,76,0,83,0,
1,-1,207,11,1,
91,0,208,4,8,
83,0,84,0,65,
0,82,0,1,-1,
3,43,0,209,12,
1,43859,210,5,2,
3,61,0,211,12,
1,43974,212,5,0,
213,11,1,16,0,
214,4,22,80,0,
76,0,85,0,83,
0,95,0,69,0,
81,0,85,0,65,
0,76,0,83,0,
1,-1,3,43,0,
215,12,1,44096,216,
5,0,217,11,1,
2,0,218,4,18,
73,0,78,0,67,
0,82,0,69,0,
77,0,69,0,78,
0,84,0,1,-1,
219,11,1,81,0,
220,4,8,80,0,
76,0,85,0,83,
0,1,-1,3,44,
0,221,12,1,41204,
222,5,0,223,11,
1,61,0,224,4,
10,67,0,79,0,
77,0,77,0,65,
0,1,-1,3,45,
0,225,12,1,39389,
226,5,2,3,45,
0,227,12,1,39476,
228,5,0,229,11,
1,10,0,230,4,
18,68,0,69,0,
67,0,82,0,69,
0,77,0,69,0,
78,0,84,0,1,
-1,3,61,0,231,
12,1,39624,232,5,
0,233,11,1,22,
0,234,4,24,77,
0,73,0,78,0,
85,0,83,0,95,
0,69,0,81,0,
85,0,65,0,76,
0,83,0,1,-1,
235,11,1,86,0,
236,4,10,77,0,
73,0,78,0,85,
0,83,0,1,-1,
3,46,0,237,12,
1,41325,238,5,14,
3,48,0,239,12,
1,38991,240,5,14,
3,48,0,239,3,
49,0,239,3,50,
0,239,3,51,0,
239,3,52,0,239,
3,53,0,239,3,
54,0,239,3,55,
0,239,3,56,0,
239,3,57,0,239,
3,101,0,241,12,
1,38454,242,5,12,
3,43,0,243,12,
1,38781,244,5,10,
3,48,0,245,12,
1,38516,246,5,12,
3,48,0,245,3,
49,0,245,3,50,
0,245,3,51,0,
245,3,52,0,245,
3,53,0,245,3,
54,0,245,3,55,
0,245,3,56,0,
245,3,57,0,245,
3,102,0,247,12,
1,38522,248,5,0,
249,11,1,866,0,
250,4,28,70,0,
76,0,79,0,65,
0,84,0,95,0,
67,0,79,0,78,
0,83,0,84,0,
65,0,78,0,84,
0,1,-1,3,70,
0,247,251,11,1,
866,0,250,1,-1,
3,49,0,245,3,
50,0,245,3,51,
0,245,3,52,0,
245,3,53,0,245,
3,54,0,245,3,
55,0,245,3,56,
0,245,3,57,0,
245,0,165,1,-1,
3,45,0,243,3,
48,0,245,3,49,
0,245,3,50,0,
245,3,51,0,245,
3,52,0,245,3,
53,0,245,3,54,
0,245,3,55,0,
245,3,56,0,245,
3,57,0,245,0,
165,1,-1,3,102,
0,247,3,69,0,
241,3,70,0,247,
252,11,1,866,0,
250,1,-1,3,49,
0,239,3,50,0,
239,3,51,0,239,
3,52,0,239,3,
53,0,239,3,54,
0,239,3,55,0,
239,3,56,0,239,
3,57,0,239,3,
101,0,241,3,102,
0,247,3,69,0,
241,3,70,0,247,
253,11,1,111,0,
254,4,12,80,0,
69,0,82,0,73,
0,79,0,68,0,
1,-1,3,47,0,
255,12,1,41446,256,
5,2,3,47,0,
257,12,1,41550,258,
5,118,3,1,0,
259,12,1,41551,260,
5,118,3,1,0,
259,3,9,0,259,
3,96,33,259,3,
13,0,259,3,0,
3,259,3,32,0,
259,3,33,0,259,
3,34,0,259,3,
35,0,259,3,36,
0,259,3,37,0,
259,3,38,0,259,
3,40,0,259,3,
41,0,259,3,42,
0,259,3,43,0,
259,3,44,0,259,
3,45,0,259,3,
46,0,259,3,47,
0,259,3,3,9,
259,3,49,0,259,
3,50,0,259,3,
48,0,259,3,52,
0,259,3,53,0,
259,3,51,0,259,
3,55,0,259,3,
56,0,259,3,54,
0,259,3,59,0,
259,3,57,0,259,
3,61,0,259,3,
62,0,259,3,60,
0,259,3,64,0,
259,3,65,0,259,
3,66,0,259,3,
67,0,259,3,68,
0,259,3,69,0,
259,3,70,0,259,
3,71,0,259,3,
72,0,259,3,73,
0,259,3,74,0,
259,3,75,0,259,
3,76,0,259,3,
77,0,259,3,78,
0,259,3,79,0,
259,3,80,0,259,
3,81,0,259,3,
82,0,259,3,83,
0,259,3,84,0,
259,3,85,0,259,
3,86,0,259,3,
87,0,259,3,88,
0,259,3,89,0,
259,3,90,0,259,
3,91,0,259,3,
92,0,259,3,93,
0,259,3,94,0,
259,3,95,0,259,
3,96,0,259,3,
97,0,259,3,98,
0,259,3,99,0,
259,3,100,0,259,
3,101,0,259,3,
102,0,259,3,103,
0,259,3,104,0,
259,3,105,0,259,
3,106,0,259,3,
107,0,259,3,15,
7,259,3,109,0,
259,3,110,0,259,
3,111,0,259,3,
112,0,259,3,113,
0,259,3,114,0,
259,3,115,0,259,
3,116,0,259,3,
117,0,259,3,118,
0,259,3,119,0,
259,3,120,0,259,
3,121,0,259,3,
122,0,259,3,108,
0,259,3,124,0,
259,3,125,0,259,
3,96,6,259,3,
123,0,259,3,126,
0,259,3,58,15,
259,3,59,15,259,
3,136,4,259,3,
160,0,259,3,170,
0,259,3,171,0,
259,3,172,0,259,
3,173,0,259,3,
178,0,259,3,176,
2,259,3,187,0,
259,3,187,1,259,
3,192,0,259,3,
41,32,259,3,197,
1,259,3,0,224,
259,3,40,32,259,
3,63,32,259,261,
11,1,1003,0,165,
1,-1,3,9,0,
259,3,96,33,259,
3,13,0,259,3,
0,3,259,3,32,
0,259,3,33,0,
259,3,34,0,259,
3,35,0,259,3,
36,0,259,3,37,
0,259,3,38,0,
259,3,40,0,259,
3,41,0,259,3,
42,0,259,3,43,
0,259,3,44,0,
259,3,45,0,259,
3,46,0,259,3,
47,0,259,3,3,
9,259,3,49,0,
259,3,50,0,259,
3,48,0,259,3,
52,0,259,3,53,
0,259,3,51,0,
259,3,55,0,259,
3,56,0,259,3,
54,0,259,3,59,
0,259,3,57,0,
259,3,61,0,259,
3,62,0,259,3,
60,0,259,3,64,
0,259,3,65,0,
259,3,66,0,259,
3,67,0,259,3,
68,0,259,3,69,
0,259,3,70,0,
259,3,71,0,259,
3,72,0,259,3,
73,0,259,3,74,
0,259,3,75,0,
259,3,76,0,259,
3,77,0,259,3,
78,0,259,3,79,
0,259,3,80,0,
259,3,81,0,259,
3,82,0,259,3,
83,0,259,3,84,
0,259,3,85,0,
259,3,86,0,259,
3,87,0,259,3,
88,0,259,3,89,
0,259,3,90,0,
259,3,91,0,259,
3,92,0,259,3,
93,0,259,3,94,
0,259,3,95,0,
259,3,96,0,259,
3,97,0,259,3,
98,0,259,3,99,
0,259,3,100,0,
259,3,101,0,259,
3,102,0,259,3,
103,0,259,3,104,
0,259,3,105,0,
259,3,106,0,259,
3,107,0,259,3,
15,7,259,3,109,
0,259,3,110,0,
259,3,111,0,259,
3,112,0,259,3,
113,0,259,3,114,
0,259,3,115,0,
259,3,116,0,259,
3,117,0,259,3,
118,0,259,3,119,
0,259,3,120,0,
259,3,121,0,259,
3,122,0,259,3,
108,0,259,3,124,
0,259,3,125,0,
259,3,96,6,259,
3,123,0,259,3,
126,0,259,3,58,
15,259,3,59,15,
259,3,136,4,259,
3,160,0,259,3,
170,0,259,3,171,
0,259,3,172,0,
259,3,173,0,259,
3,178,0,259,3,
176,2,259,3,187,
0,259,3,187,1,
259,3,192,0,259,
3,41,32,259,3,
197,1,259,3,0,
224,259,3,40,32,
259,3,63,32,259,
262,11,1,1003,0,
165,1,-1,3,61,
0,263,12,1,41801,
264,5,0,265,11,
1,34,0,266,4,
24,83,0,76,0,
65,0,83,0,72,
0,95,0,69,0,
81,0,85,0,65,
0,76,0,83,0,
1,-1,267,11,1,
96,0,268,4,10,
83,0,76,0,65,
0,83,0,72,0,
1,-1,3,48,0,
269,12,1,38044,270,
5,13,3,120,0,
271,12,1,38068,272,
5,22,3,102,0,
273,12,1,38069,274,
5,22,3,102,0,
273,3,48,0,273,
3,49,0,273,3,
50,0,273,3,51,
0,273,3,52,0,
273,3,53,0,273,
3,54,0,273,3,
55,0,273,3,56,
0,273,3,57,0,
273,3,97,0,273,
3,98,0,273,3,
99,0,273,3,100,
0,273,3,101,0,
273,3,65,0,273,
3,66,0,273,3,
67,0,273,3,68,
0,273,3,69,0,
273,3,70,0,273,
275,11,1,847,0,
276,4,40,72,0,
69,0,88,0,95,
0,73,0,78,0,
84,0,69,0,71,
0,69,0,82,0,
95,0,67,0,79,
0,78,0,83,0,
84,0,65,0,78,
0,84,0,1,-1,
3,48,0,273,3,
49,0,273,3,50,
0,273,3,51,0,
273,3,52,0,273,
3,53,0,273,3,
54,0,273,3,55,
0,273,3,56,0,
273,3,57,0,273,
3,97,0,273,3,
98,0,273,3,99,
0,273,3,100,0,
273,3,101,0,273,
3,65,0,273,3,
66,0,273,3,67,
0,273,3,68,0,
273,3,69,0,273,
3,70,0,273,0,
165,1,-1,3,48,
0,277,12,1,38346,
278,5,11,3,46,
0,279,12,1,38449,
280,5,14,3,48,
0,239,3,49,0,
239,3,50,0,239,
3,51,0,239,3,
52,0,239,3,53,
0,239,3,54,0,
239,3,55,0,239,
3,56,0,239,3,
57,0,239,3,101,
0,241,3,102,0,
247,3,69,0,241,
3,70,0,247,281,
11,1,866,0,250,
1,-1,3,48,0,
277,3,49,0,277,
3,50,0,277,3,
51,0,277,3,52,
0,277,3,53,0,
277,3,54,0,277,
3,55,0,277,3,
56,0,277,3,57,
0,277,282,11,1,
841,0,283,4,32,
73,0,78,0,84,
0,69,0,71,0,
69,0,82,0,95,
0,67,0,79,0,
78,0,83,0,84,
0,65,0,78,0,
84,0,1,-1,3,
49,0,277,3,50,
0,277,3,88,0,
271,3,52,0,277,
3,53,0,277,3,
51,0,277,3,55,
0,277,3,56,0,
277,3,54,0,277,
3,46,0,279,3,
57,0,277,284,11,
1,841,0,283,1,
-1,3,49,0,277,
3,50,0,277,3,
51,0,277,3,52,
0,277,3,53,0,
277,3,54,0,277,
3,55,0,277,3,
56,0,277,3,57,
0,277,3,59,0,
285,12,1,41928,286,
5,0,287,11,1,
46,0,288,4,18,
83,0,69,0,77,
0,73,0,67,0,
79,0,76,0,79,
0,78,0,1,-1,
3,60,0,289,12,
1,42896,290,5,2,
3,60,0,291,12,
1,43010,292,5,0,
293,11,1,197,0,
294,4,20,76,0,
69,0,70,0,84,
0,95,0,83,0,
72,0,73,0,70,
0,84,0,1,-1,
3,61,0,295,12,
1,43131,296,5,0,
297,11,1,148,0,
298,4,22,76,0,
69,0,83,0,83,
0,95,0,69,0,
81,0,85,0,65,
0,76,0,83,0,
1,-1,299,11,1,
116,0,300,4,20,
76,0,69,0,70,
0,84,0,95,0,
65,0,78,0,71,
0,76,0,69,0,
1,-1,3,61,0,
301,12,1,43257,302,
5,1,3,61,0,
303,12,1,43372,304,
5,0,305,11,1,
136,0,306,4,26,
69,0,81,0,85,
0,65,0,76,0,
83,0,95,0,69,
0,81,0,85,0,
65,0,76,0,83,
0,1,-1,307,11,
1,66,0,308,4,
12,69,0,81,0,
85,0,65,0,76,
0,83,0,1,-1,
3,62,0,309,12,
1,43498,310,5,2,
3,61,0,311,12,
1,43613,312,5,0,
313,11,1,154,0,
314,4,28,71,0,
82,0,69,0,65,
0,84,0,69,0,
82,0,95,0,69,
0,81,0,85,0,
65,0,76,0,83,
0,1,-1,3,62,
0,315,12,1,43734,
316,5,0,317,11,
1,203,0,318,4,
22,82,0,73,0,
71,0,72,0,84,
0,95,0,83,0,
72,0,73,0,70,
0,84,0,1,-1,
319,11,1,121,0,
320,4,22,82,0,
73,0,71,0,72,
0,84,0,95,0,
65,0,78,0,71,
0,76,0,69,0,
1,-1,3,64,0,
321,12,1,42049,322,
5,0,323,11,1,
106,0,324,4,4,
65,0,84,0,1,
-1,3,65,0,325,
12,1,1023,326,5,
63,3,109,0,327,
12,1,1024,328,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,329,11,
1,829,0,330,4,
10,73,0,68,0,
69,0,78,0,84,
0,1,-1,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,331,11,1,829,
0,330,1,-1,3,
66,0,325,3,67,
0,325,3,68,0,
325,3,69,0,325,
3,70,0,325,3,
71,0,325,3,72,
0,325,3,73,0,
325,3,74,0,325,
3,75,0,325,3,
76,0,325,3,77,
0,325,3,78,0,
325,3,79,0,325,
3,80,0,325,3,
81,0,325,3,82,
0,325,3,83,0,
325,3,84,0,325,
3,85,0,325,3,
86,0,325,3,87,
0,325,3,88,0,
325,3,89,0,325,
3,90,0,325,3,
91,0,332,12,1,
39872,333,5,0,334,
11,1,126,0,335,
4,24,76,0,69,
0,70,0,84,0,
95,0,66,0,82,
0,65,0,67,0,
75,0,69,0,84,
0,1,-1,3,93,
0,336,12,1,40237,
337,5,0,338,11,
1,131,0,339,4,
26,82,0,73,0,
71,0,72,0,84,
0,95,0,66,0,
82,0,65,0,67,
0,75,0,69,0,
84,0,1,-1,3,
94,0,340,12,1,
44221,341,5,0,342,
11,1,170,0,343,
4,10,67,0,65,
0,82,0,69,0,
84,0,1,-1,3,
95,0,325,3,97,
0,344,12,1,20025,
345,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,346,
12,1,20060,347,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,348,12,1,
20095,349,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,350,12,1,20138,
351,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,352,12,
1,20183,353,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
354,12,1,20233,355,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,356,
11,1,380,0,357,
4,24,65,0,84,
0,84,0,65,0,
67,0,72,0,95,
0,69,0,86,0,
69,0,78,0,84,
0,1,-1,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,358,
11,1,829,0,330,
1,-1,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,359,11,
1,829,0,330,1,
-1,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
360,11,1,829,0,
330,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,361,
12,1,20626,362,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,363,
12,1,20659,364,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,365,12,1,
20689,366,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
367,12,1,20724,368,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
369,12,1,20810,370,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,371,12,
1,20845,372,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,373,12,1,
20888,374,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,375,12,1,
20921,376,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
377,12,1,20970,378,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
379,12,1,21017,380,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,381,12,
1,21052,382,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,383,11,1,
350,0,384,4,38,
65,0,84,0,95,
0,82,0,79,0,
84,0,95,0,84,
0,65,0,82,0,
71,0,69,0,84,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
385,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,386,11,1,829,
0,330,1,-1,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,387,
11,1,829,0,330,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
388,11,1,829,0,
330,1,-1,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,389,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
390,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,391,11,1,829,
0,330,1,-1,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,392,
11,1,829,0,330,
1,-1,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,393,11,1,
829,0,330,1,-1,
3,115,0,327,3,
116,0,394,12,1,
21861,395,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,396,12,1,21904,
397,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,398,12,1,21937,
399,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,400,
12,1,21986,401,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,402,
12,1,22033,403,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,404,12,1,
22068,405,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,406,11,1,367,
0,407,4,30,65,
0,84,0,95,0,
84,0,65,0,82,
0,71,0,69,0,
84,0,95,0,69,
0,86,0,69,0,
78,0,84,0,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,408,11,1,829,
0,330,1,-1,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,409,11,1,
829,0,330,1,-1,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
410,11,1,829,0,
330,1,-1,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,411,11,1,829,
0,330,1,-1,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,412,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,413,11,1,829,
0,330,1,-1,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,414,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
415,11,1,829,0,
330,1,-1,3,98,
0,325,3,99,0,
416,12,1,22787,417,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,418,12,
1,22817,419,5,63,
3,109,0,327,3,
110,0,420,12,1,
22846,421,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
422,12,1,22881,423,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
424,12,1,22914,425,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,426,12,
1,22944,427,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,428,12,1,22998,
429,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
430,11,1,450,0,
431,4,26,67,0,
79,0,78,0,84,
0,82,0,79,0,
76,0,95,0,69,
0,86,0,69,0,
78,0,84,0,1,
-1,432,11,1,829,
0,330,1,-1,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,433,
11,1,829,0,330,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
434,11,1,829,0,
330,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,435,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,436,
12,1,23471,437,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,438,12,1,
23525,439,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,440,12,
1,23576,441,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,442,12,1,
23610,443,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,444,12,
1,23661,445,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,446,12,1,23691,
447,5,63,3,109,
0,327,3,110,0,
448,12,1,23720,449,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
450,12,1,23806,451,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,452,
12,1,23840,453,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,454,12,1,
23875,455,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,456,12,1,23918,
457,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,458,12,1,23951,
459,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,460,
12,1,23986,461,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,462,11,
1,431,0,463,4,
42,67,0,79,0,
76,0,76,0,73,
0,83,0,73,0,
79,0,78,0,95,
0,83,0,84,0,
65,0,82,0,84,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
464,11,1,829,0,
330,1,-1,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,465,11,1,829,
0,330,1,-1,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,466,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,467,11,1,829,
0,330,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,468,
12,1,24453,469,5,
63,3,109,0,327,
3,110,0,470,12,
1,24482,471,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,472,
12,1,24528,473,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,474,11,
1,414,0,475,4,
38,67,0,79,0,
76,0,76,0,73,
0,83,0,73,0,
79,0,78,0,95,
0,69,0,78,0,
68,0,95,0,69,
0,86,0,69,0,
78,0,84,0,1,
-1,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,476,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
477,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,478,11,1,829,
0,330,1,-1,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,479,11,1,
401,0,480,4,30,
67,0,79,0,76,
0,76,0,73,0,
83,0,73,0,79,
0,78,0,95,0,
69,0,86,0,69,
0,78,0,84,0,
1,-1,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,481,11,1,829,
0,330,1,-1,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,482,
11,1,829,0,330,
1,-1,3,106,0,
327,3,107,0,327,
3,108,0,327,483,
11,1,829,0,330,
1,-1,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,484,11,1,829,
0,330,1,-1,3,
106,0,327,3,107,
0,327,3,108,0,
327,485,11,1,829,
0,330,1,-1,486,
11,1,829,0,330,
1,-1,487,11,1,
829,0,330,1,-1,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,488,12,
1,25477,489,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,490,12,1,
25520,491,5,63,3,
109,0,327,3,110,
0,492,12,1,25549,
493,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,494,
12,1,25598,495,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,496,
12,1,25645,497,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
498,12,1,25691,499,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,500,
11,1,390,0,501,
4,26,67,0,72,
0,65,0,78,0,
71,0,69,0,68,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,502,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,503,11,
1,829,0,330,1,
-1,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,504,11,1,829,
0,330,1,-1,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,505,11,
1,829,0,330,1,
-1,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
506,11,1,829,0,
330,1,-1,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,507,
11,1,829,0,330,
1,-1,3,100,0,
508,12,1,26268,509,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,510,12,
1,26298,511,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,512,11,1,
223,0,513,4,4,
68,0,79,0,1,
-1,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,514,12,1,26431,
515,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,516,
12,1,26466,517,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,518,12,
1,26509,519,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,520,12,1,
26543,521,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,522,12,1,
26590,523,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,524,12,1,
26623,525,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,526,12,
1,26660,527,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,528,12,
1,26707,529,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,530,12,
1,26740,531,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,532,11,1,
461,0,533,4,32,
68,0,65,0,84,
0,65,0,83,0,
69,0,82,0,86,
0,69,0,82,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,534,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,535,11,
1,829,0,330,1,
-1,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,536,11,
1,829,0,330,1,
-1,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,537,
11,1,829,0,330,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
538,11,1,829,0,
330,1,-1,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,539,11,1,
829,0,330,1,-1,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,540,
11,1,829,0,330,
1,-1,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,541,11,1,
829,0,330,1,-1,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
542,12,1,27515,543,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,544,
12,1,27563,545,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,546,12,
1,27606,547,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
548,12,1,27642,549,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,550,12,
1,27696,551,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,552,12,1,27731,
553,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
554,11,1,245,0,
555,4,26,68,0,
69,0,70,0,65,
0,85,0,76,0,
84,0,95,0,83,
0,84,0,65,0,
84,0,69,0,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,556,11,1,829,
0,330,1,-1,557,
11,1,829,0,330,
1,-1,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,558,11,
1,829,0,330,1,
-1,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
559,11,1,829,0,
330,1,-1,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,560,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,561,11,
1,829,0,330,1,
-1,3,101,0,562,
12,1,28309,563,5,
63,3,109,0,564,
12,1,28337,565,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,566,12,
1,28380,567,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,568,
12,1,28431,569,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,570,12,1,
28485,571,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,572,11,1,475,
0,573,4,22,69,
0,77,0,65,0,
73,0,76,0,95,
0,69,0,86,0,
69,0,78,0,84,
0,1,-1,574,11,
1,829,0,330,1,
-1,3,106,0,327,
3,107,0,327,3,
108,0,327,575,11,
1,829,0,330,1,
-1,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
576,11,1,829,0,
330,1,-1,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
577,12,1,28843,578,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,579,
12,1,28877,580,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,581,
12,1,28924,582,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,583,11,
1,215,0,584,4,
8,69,0,76,0,
83,0,69,0,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,585,
11,1,829,0,330,
1,-1,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,586,11,1,829,
0,330,1,-1,587,
11,1,829,0,330,
1,-1,3,102,0,
588,12,1,29270,589,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,590,12,
1,29300,591,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,592,12,
1,29333,593,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,594,11,1,
238,0,595,4,6,
70,0,79,0,82,
0,1,-1,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,596,11,1,829,
0,330,1,-1,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,597,12,
1,29564,598,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,599,12,1,29594,
600,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
601,12,1,29637,602,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,603,12,
1,29672,604,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,605,11,1,
294,0,606,4,20,
70,0,76,0,79,
0,65,0,84,0,
95,0,84,0,89,
0,80,0,69,0,
1,-1,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,607,11,1,
829,0,330,1,-1,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,608,
11,1,829,0,330,
1,-1,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,609,11,1,
829,0,330,1,-1,
610,11,1,829,0,
330,1,-1,3,103,
0,325,3,104,0,
611,12,1,30112,612,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,613,12,
1,30147,614,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,615,12,1,30182,
616,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,617,12,
1,30213,618,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,619,12,
1,30299,620,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,621,12,
1,30332,622,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,623,12,
1,30379,624,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,625,12,1,
30413,626,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,627,
12,1,30444,628,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,629,12,1,
30474,630,5,63,3,
109,0,327,3,110,
0,631,12,1,30503,
632,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
633,12,1,30537,634,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
635,12,1,30584,636,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,637,
11,1,484,0,638,
4,38,72,0,84,
0,84,0,80,0,
95,0,82,0,69,
0,83,0,80,0,
79,0,78,0,83,
0,69,0,95,0,
69,0,86,0,69,
0,78,0,84,0,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
639,11,1,829,0,
330,1,-1,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,640,11,1,
829,0,330,1,-1,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,641,
11,1,829,0,330,
1,-1,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,642,11,1,
829,0,330,1,-1,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,643,11,1,829,
0,330,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,644,11,
1,829,0,330,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,645,
11,1,829,0,330,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
646,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,647,11,1,829,
0,330,1,-1,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
648,11,1,829,0,
330,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,649,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,650,11,1,829,
0,330,1,-1,3,
105,0,651,12,1,
31673,652,5,63,3,
109,0,327,3,110,
0,653,12,1,31702,
654,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,655,
12,1,31737,656,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,657,
12,1,31784,658,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,659,12,1,
31833,660,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,661,12,1,
31880,662,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,663,12,1,
31913,664,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,665,11,1,283,
0,666,4,24,73,
0,78,0,84,0,
69,0,71,0,69,
0,82,0,95,0,
84,0,89,0,80,
0,69,0,1,-1,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,667,11,
1,829,0,330,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,668,
11,1,829,0,330,
1,-1,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,669,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,670,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,671,11,1,829,
0,330,1,-1,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,672,12,
1,32441,673,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,674,11,1,
209,0,675,4,4,
73,0,70,0,1,
-1,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
676,11,1,829,0,
330,1,-1,3,106,
0,677,12,1,32634,
678,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,679,12,
1,32670,680,5,63,
3,109,0,681,12,
1,32698,682,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
683,12,1,32729,684,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,685,
11,1,265,0,686,
4,8,74,0,85,
0,77,0,80,0,
1,-1,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,687,11,
1,829,0,330,1,
-1,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,688,
11,1,829,0,330,
1,-1,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,689,11,
1,829,0,330,1,
-1,3,107,0,690,
12,1,33115,691,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,692,
12,1,33162,693,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,694,12,1,
33202,695,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,696,11,1,313,
0,697,4,16,75,
0,69,0,89,0,
95,0,84,0,89,
0,80,0,69,0,
1,-1,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,698,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,699,11,
1,829,0,330,1,
-1,3,108,0,700,
12,1,33476,701,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,702,12,
1,33519,703,5,63,
3,109,0,327,3,
110,0,704,12,1,
33548,705,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,706,12,
1,33594,707,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,708,12,
1,33680,709,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
710,12,1,33725,711,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,712,12,
1,33755,713,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,714,12,1,33809,
715,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,716,
12,1,33863,717,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
718,12,1,33914,719,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,720,
12,1,33948,721,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
722,12,1,33999,723,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,724,12,
1,34029,725,5,63,
3,109,0,327,3,
110,0,726,12,1,
34058,727,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,728,12,1,
34144,729,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,730,12,1,34178,
731,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,732,
12,1,34213,733,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,734,12,
1,34256,735,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,736,12,
1,34289,737,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,738,12,1,34324,
739,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
740,11,1,541,0,
741,4,52,76,0,
65,0,78,0,68,
0,95,0,67,0,
79,0,76,0,76,
0,73,0,83,0,
73,0,79,0,78,
0,95,0,83,0,
84,0,65,0,82,
0,84,0,95,0,
69,0,86,0,69,
0,78,0,84,0,
1,-1,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,742,11,1,
829,0,330,1,-1,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,743,11,
1,829,0,330,1,
-1,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
744,11,1,829,0,
330,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,745,11,
1,829,0,330,1,
-1,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,746,12,1,34791,
747,5,63,3,109,
0,327,3,110,0,
748,12,1,34820,749,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,750,12,1,34866,
751,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
752,11,1,519,0,
753,4,48,76,0,
65,0,78,0,68,
0,95,0,67,0,
79,0,76,0,76,
0,73,0,83,0,
73,0,79,0,78,
0,95,0,69,0,
78,0,68,0,95,
0,69,0,86,0,
69,0,78,0,84,
0,1,-1,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
754,11,1,829,0,
330,1,-1,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,755,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,756,11,
1,829,0,330,1,
-1,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,757,
11,1,501,0,758,
4,40,76,0,65,
0,78,0,68,0,
95,0,67,0,79,
0,76,0,76,0,
73,0,83,0,73,
0,79,0,78,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,759,11,
1,829,0,330,1,
-1,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,760,11,1,829,
0,330,1,-1,3,
106,0,327,3,107,
0,327,3,108,0,
327,761,11,1,829,
0,330,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,762,11,
1,829,0,330,1,
-1,3,106,0,327,
3,107,0,327,3,
108,0,327,763,11,
1,829,0,330,1,
-1,764,11,1,829,
0,330,1,-1,765,
11,1,829,0,330,
1,-1,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,766,11,1,
829,0,330,1,-1,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,767,11,1,829,
0,330,1,-1,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,768,11,1,
829,0,330,1,-1,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,769,11,1,
829,0,330,1,-1,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,770,
11,1,829,0,330,
1,-1,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,771,12,
1,36167,772,5,63,
3,109,0,327,3,
110,0,773,12,1,
36196,774,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,775,12,1,36249,
776,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,777,12,1,36335,
778,5,63,3,109,
0,779,12,1,36363,
780,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,781,12,1,36410,
782,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
783,12,1,36444,784,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,785,
12,1,36478,786,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,787,12,
1,36521,788,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,789,12,1,36570,
790,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,791,12,1,36617,
792,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
793,11,1,565,0,
794,4,36,76,0,
73,0,78,0,75,
0,95,0,77,0,
69,0,83,0,83,
0,65,0,71,0,
69,0,95,0,69,
0,86,0,69,0,
78,0,84,0,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,795,
11,1,829,0,330,
1,-1,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,796,11,1,
829,0,330,1,-1,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,797,
11,1,829,0,330,
1,-1,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,798,11,1,829,
0,330,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,799,11,
1,829,0,330,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,800,
11,1,829,0,330,
1,-1,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
801,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,802,11,1,829,
0,330,1,-1,3,
108,0,327,803,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
804,12,1,37401,805,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,806,12,
1,37436,807,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,808,12,
1,37483,809,5,63,
3,109,0,327,3,
110,0,810,12,1,
37512,811,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,812,11,1,581,
0,813,4,24,76,
0,73,0,83,0,
84,0,69,0,78,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,814,
11,1,829,0,330,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
815,11,1,342,0,
816,4,18,76,0,
73,0,83,0,84,
0,95,0,84,0,
89,0,80,0,69,
0,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,817,11,
1,829,0,330,1,
-1,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
818,11,1,829,0,
330,1,-1,3,106,
0,327,3,107,0,
327,3,108,0,327,
819,11,1,829,0,
330,1,-1,3,109,
0,820,12,1,1290,
821,5,63,3,109,
0,327,3,110,0,
327,3,111,0,822,
12,1,1320,823,5,
63,3,109,0,327,
3,110,0,824,12,
1,1349,825,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,826,12,
1,1396,827,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,828,12,1,1436,
829,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
830,11,1,591,0,
831,4,22,77,0,
79,0,78,0,69,
0,89,0,95,0,
69,0,86,0,69,
0,78,0,84,0,
1,-1,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,832,11,1,
829,0,330,1,-1,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,833,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,834,12,1,
1717,835,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,836,12,
1,1768,837,5,63,
3,109,0,327,3,
110,0,838,12,1,
1797,839,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
840,12,1,1846,841,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
842,12,1,1932,843,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,844,
12,1,1966,845,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,846,12,1,
2001,847,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,848,12,1,2044,
849,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,850,12,1,2077,
851,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,852,
12,1,2112,853,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,854,11,
1,614,0,855,4,
36,77,0,79,0,
86,0,73,0,78,
0,71,0,95,0,
83,0,84,0,65,
0,82,0,84,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,856,
11,1,829,0,330,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
857,11,1,829,0,
330,1,-1,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,858,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
859,11,1,829,0,
330,1,-1,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,860,12,
1,2579,861,5,63,
3,109,0,327,3,
110,0,862,12,1,
2608,863,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,864,12,
1,2654,865,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,866,11,1,
600,0,867,4,32,
77,0,79,0,86,
0,73,0,78,0,
71,0,95,0,69,
0,78,0,68,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,868,11,1,829,
0,330,1,-1,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,869,11,
1,829,0,330,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,870,
11,1,829,0,330,
1,-1,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
871,11,1,829,0,
330,1,-1,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,872,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
873,11,1,829,0,
330,1,-1,3,106,
0,327,3,107,0,
327,3,108,0,327,
874,11,1,829,0,
330,1,-1,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
875,11,1,829,0,
330,1,-1,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,876,11,
1,829,0,330,1,
-1,3,110,0,877,
12,1,3451,878,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,879,12,1,
3481,880,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
881,12,1,3516,882,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
883,12,1,3602,884,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,885,
12,1,3645,886,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,887,12,1,
3680,888,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,889,12,1,
3766,890,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,891,12,1,
3799,892,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
893,12,1,3829,894,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,895,12,
1,3864,896,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,897,12,
1,3950,898,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,899,12,1,3985,
900,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
901,12,1,4028,902,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
903,12,1,4061,904,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,905,12,
1,4110,906,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,907,12,
1,4157,908,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,909,12,1,4192,
910,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
911,11,1,643,0,
912,4,46,78,0,
79,0,84,0,95,
0,65,0,84,0,
95,0,82,0,79,
0,84,0,95,0,
84,0,65,0,82,
0,71,0,69,0,
84,0,95,0,69,
0,86,0,69,0,
78,0,84,0,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,913,11,1,829,
0,330,1,-1,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,914,11,1,
829,0,330,1,-1,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
915,11,1,829,0,
330,1,-1,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,916,11,1,829,
0,330,1,-1,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,917,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,918,11,1,829,
0,330,1,-1,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,919,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
920,11,1,829,0,
330,1,-1,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,921,11,
1,829,0,330,1,
-1,3,115,0,327,
3,116,0,922,12,
1,5001,923,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,924,12,1,
5044,925,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,926,12,1,
5077,927,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
928,12,1,5126,929,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
930,12,1,5173,931,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,932,12,
1,5208,933,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,934,11,1,
664,0,935,4,38,
78,0,79,0,84,
0,95,0,65,0,
84,0,95,0,84,
0,65,0,82,0,
71,0,69,0,84,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
936,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,937,11,1,829,
0,330,1,-1,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,938,
11,1,829,0,330,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
939,11,1,829,0,
330,1,-1,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,940,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
941,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,942,11,1,829,
0,330,1,-1,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,943,
11,1,829,0,330,
1,-1,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,944,11,1,829,
0,330,1,-1,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,945,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,946,12,1,6087,
947,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
948,12,1,6121,949,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
950,12,1,6168,951,
5,63,3,109,0,
327,3,110,0,952,
12,1,6197,953,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,954,12,
1,6231,955,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,956,12,1,6261,
957,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,958,12,1,6294,
959,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
960,11,1,630,0,
961,4,30,78,0,
79,0,95,0,83,
0,69,0,78,0,
83,0,79,0,82,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,962,11,
1,829,0,330,1,
-1,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,963,11,1,829,
0,330,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,964,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
965,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,966,11,1,829,
0,330,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,967,11,
1,829,0,330,1,
-1,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,968,
11,1,829,0,330,
1,-1,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,969,11,1,
829,0,330,1,-1,
3,111,0,970,12,
1,7052,971,5,63,
3,109,0,327,3,
110,0,972,12,1,
7081,973,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,974,12,1,
7167,975,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,976,12,1,
7200,977,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,978,12,1,
7247,979,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,980,
12,1,7288,981,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,982,11,
1,695,0,983,4,
24,79,0,78,0,
95,0,82,0,69,
0,90,0,95,0,
69,0,86,0,69,
0,78,0,84,0,
1,-1,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,984,11,
1,829,0,330,1,
-1,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,985,
11,1,829,0,330,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
986,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,987,11,1,829,
0,330,1,-1,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,988,12,1,
7696,989,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,990,12,1,
7748,991,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,992,12,1,
7795,993,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,994,
12,1,7840,995,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,996,12,1,
7875,997,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,998,12,1,
7961,999,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,1000,12,1,
7994,1001,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,1002,12,1,
8041,1003,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,1004,
12,1,8082,1005,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1006,11,
1,681,0,1007,4,
32,79,0,66,0,
74,0,69,0,67,
0,84,0,95,0,
82,0,69,0,90,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1008,11,1,829,
0,330,1,-1,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1009,11,1,
829,0,330,1,-1,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1010,11,
1,829,0,330,1,
-1,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1011,
11,1,829,0,330,
1,-1,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1012,11,1,
829,0,330,1,-1,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1013,11,1,829,
0,330,1,-1,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1014,11,1,
829,0,330,1,-1,
3,107,0,327,3,
108,0,327,1015,11,
1,829,0,330,1,
-1,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1016,11,1,829,
0,330,1,-1,3,
112,0,325,3,113,
0,325,3,114,0,
1017,12,1,8855,1018,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,1019,12,
1,8885,1020,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,1021,12,1,8920,
1022,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
1023,12,1,8963,1024,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,1025,12,
1,8998,1026,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,1027,
12,1,9049,1028,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,1029,12,1,
9079,1030,5,63,3,
109,0,327,3,110,
0,1031,12,1,9108,
1032,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1033,11,1,330,0,
1034,4,26,82,0,
79,0,84,0,65,
0,84,0,73,0,
79,0,78,0,95,
0,84,0,89,0,
80,0,69,0,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1035,11,1,829,0,
330,1,-1,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1036,11,
1,829,0,330,1,
-1,3,106,0,327,
3,107,0,327,3,
108,0,327,1037,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1038,11,1,829,
0,330,1,-1,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1039,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1040,11,1,829,
0,330,1,-1,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,1041,12,1,
9731,1042,5,63,3,
109,0,327,3,110,
0,1043,12,1,9760,
1044,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,1045,12,1,9846,
1046,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,1047,
12,1,9881,1048,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
1049,12,1,9932,1050,
5,63,3,109,0,
1051,12,1,9960,1052,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
1053,12,1,10007,1054,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
1055,12,1,10093,1056,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,1057,12,1,
10124,1058,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,1059,12,1,
10171,1060,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,1061,12,1,
10204,1062,5,63,3,
109,0,1063,12,1,
10232,1064,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,1065,12,
1,10283,1066,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,1067,12,1,
10317,1068,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,1069,12,1,10351,
1070,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,1071,12,1,
10402,1072,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
1073,12,1,10432,1074,
5,63,3,109,0,
327,3,110,0,1075,
12,1,10461,1076,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,1077,12,
1,10495,1078,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1079,11,1,
720,0,1080,4,52,
82,0,85,0,78,
0,95,0,84,0,
73,0,77,0,69,
0,95,0,80,0,
69,0,82,0,77,
0,73,0,83,0,
83,0,73,0,79,
0,78,0,83,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1081,11,
1,829,0,330,1,
-1,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1082,11,1,829,0,
330,1,-1,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1083,11,
1,829,0,330,1,
-1,3,106,0,327,
3,107,0,327,3,
108,0,327,1084,11,
1,829,0,330,1,
-1,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1085,11,1,829,0,
330,1,-1,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1086,11,1,
829,0,330,1,-1,
3,106,0,327,3,
107,0,327,3,108,
0,327,1087,11,1,
829,0,330,1,-1,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1088,11,
1,829,0,330,1,
-1,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1089,
11,1,829,0,330,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1090,11,1,829,0,
330,1,-1,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1091,
11,1,829,0,330,
1,-1,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1092,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1093,11,1,829,
0,330,1,-1,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1094,11,1,
829,0,330,1,-1,
3,106,0,327,3,
107,0,327,3,108,
0,327,1095,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1096,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1097,11,1,829,
0,330,1,-1,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1098,11,
1,829,0,330,1,
-1,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,1099,12,
1,12022,1100,5,63,
3,109,0,1101,12,
1,12050,1102,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,1103,12,1,12080,
1104,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,1105,
12,1,12115,1106,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,1107,
12,1,12162,1108,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,1109,
12,1,12248,1110,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
1111,12,1,12294,1112,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,1113,
12,1,12337,1114,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,1115,12,1,
12372,1116,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,1117,12,1,12415,
1118,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1119,11,1,705,0,
1120,4,34,82,0,
69,0,77,0,79,
0,84,0,69,0,
95,0,68,0,65,
0,84,0,65,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1121,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1122,11,1,829,
0,330,1,-1,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1123,11,
1,829,0,330,1,
-1,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1124,11,
1,829,0,330,1,
-1,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1125,
11,1,829,0,330,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1126,11,1,829,0,
330,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1127,11,
1,829,0,330,1,
-1,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1128,11,1,829,
0,330,1,-1,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,1129,12,1,13137,
1130,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,1131,12,
1,13173,1132,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,1133,12,
1,13206,1134,5,63,
3,109,0,327,3,
110,0,1135,12,1,
13235,1136,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1137,11,1,273,
0,1138,4,12,82,
0,69,0,84,0,
85,0,82,0,78,
0,1,-1,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1139,11,1,
829,0,330,1,-1,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1140,11,
1,829,0,330,1,
-1,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1141,11,1,
829,0,330,1,-1,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1142,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1143,11,1,829,
0,330,1,-1,3,
115,0,1144,12,1,
13776,1145,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
1146,12,1,13811,1147,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
1148,12,1,13844,1149,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,1150,12,1,13895,
1151,5,63,3,109,
0,327,3,110,0,
1152,12,1,13924,1153,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,1154,12,
1,13973,1155,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1156,11,1,
303,0,1157,4,22,
83,0,84,0,82,
0,73,0,78,0,
71,0,95,0,84,
0,89,0,80,0,
69,0,1,-1,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1158,
11,1,829,0,330,
1,-1,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1159,11,1,829,
0,330,1,-1,3,
106,0,327,3,107,
0,327,3,108,0,
327,1160,11,1,829,
0,330,1,-1,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,1161,12,1,
14334,1162,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
1163,12,1,14369,1164,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
1165,12,1,14416,1166,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
1167,12,1,14502,1168,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
1169,12,1,14549,1170,
5,63,3,109,0,
327,3,110,0,1171,
12,1,14578,1172,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,1173,12,1,
14613,1174,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,1175,12,1,
14646,1176,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
1177,12,1,14686,1178,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1179,
11,1,754,0,1180,
4,34,83,0,84,
0,65,0,84,0,
69,0,95,0,69,
0,78,0,84,0,
82,0,89,0,95,
0,69,0,86,0,
69,0,78,0,84,
0,1,-1,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1181,11,
1,829,0,330,1,
-1,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1182,
11,1,829,0,330,
1,-1,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1183,11,1,
829,0,330,1,-1,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,1184,
12,1,15068,1185,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
1186,12,1,15119,1187,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,1188,12,
1,15154,1189,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1190,11,1,
769,0,1191,4,32,
83,0,84,0,65,
0,84,0,69,0,
95,0,69,0,88,
0,73,0,84,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1192,
11,1,829,0,330,
1,-1,3,106,0,
327,3,107,0,327,
3,108,0,327,1193,
11,1,829,0,330,
1,-1,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1194,11,1,829,
0,330,1,-1,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1195,11,1,
829,0,330,1,-1,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1196,11,
1,256,0,1197,4,
10,83,0,84,0,
65,0,84,0,69,
0,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1198,11,1,829,
0,330,1,-1,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1199,
11,1,829,0,330,
1,-1,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1200,11,1,829,
0,330,1,-1,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
1201,12,1,15863,1202,
5,63,3,109,0,
327,3,110,0,1203,
12,1,15892,1204,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,1205,12,
1,15926,1206,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,1207,12,1,15956,
1208,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,1209,12,1,15989,
1210,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1211,11,1,744,0,
1212,4,24,83,0,
69,0,78,0,83,
0,79,0,82,0,
95,0,69,0,86,
0,69,0,78,0,
84,0,1,-1,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1213,11,1,
829,0,330,1,-1,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1214,11,1,829,0,
330,1,-1,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1215,11,1,
829,0,330,1,-1,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1216,
11,1,829,0,330,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1217,11,1,829,0,
330,1,-1,3,116,
0,1218,12,1,16537,
1219,5,63,3,109,
0,327,3,110,0,
327,3,111,0,1220,
12,1,16567,1221,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,1222,12,1,16603,
1223,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,1224,12,
1,16648,1225,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
1226,12,1,16698,1227,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
1228,12,1,16784,1229,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,1230,
12,1,16818,1231,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,1232,12,1,
16853,1233,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,1234,12,1,16896,
1235,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,1236,12,1,16929,
1237,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,1238,
12,1,16964,1239,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1240,11,
1,801,0,1241,4,
34,84,0,79,0,
85,0,67,0,72,
0,95,0,83,0,
84,0,65,0,82,
0,84,0,95,0,
69,0,86,0,69,
0,78,0,84,0,
1,-1,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1242,11,1,
829,0,330,1,-1,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1243,11,
1,829,0,330,1,
-1,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1244,11,1,829,0,
330,1,-1,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1245,11,
1,829,0,330,1,
-1,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,1246,12,1,17431,
1247,5,63,3,109,
0,327,3,110,0,
1248,12,1,17460,1249,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,1250,12,1,17506,
1251,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1252,11,1,816,0,
1253,4,30,84,0,
79,0,85,0,67,
0,72,0,95,0,
69,0,78,0,68,
0,95,0,69,0,
86,0,69,0,78,
0,84,0,1,-1,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1254,11,1,
829,0,330,1,-1,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1255,
11,1,829,0,330,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1256,11,1,829,0,
330,1,-1,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1257,11,1,792,
0,1258,4,22,84,
0,79,0,85,0,
67,0,72,0,95,
0,69,0,86,0,
69,0,78,0,84,
0,1,-1,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,327,1259,
11,1,829,0,330,
1,-1,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1260,11,
1,829,0,330,1,
-1,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1261,11,1,
829,0,330,1,-1,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,1262,12,1,
18148,1263,5,63,3,
109,0,1264,12,1,
18176,1265,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,1266,12,1,
18223,1267,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,1268,12,1,
18256,1269,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1270,11,1,783,
0,1271,4,22,84,
0,73,0,77,0,
69,0,82,0,95,
0,69,0,86,0,
69,0,78,0,84,
0,1,-1,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1272,11,1,829,
0,330,1,-1,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1273,11,1,
829,0,330,1,-1,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1274,11,
1,829,0,330,1,
-1,3,106,0,327,
3,107,0,327,3,
108,0,327,1275,11,
1,829,0,330,1,
-1,3,117,0,325,
3,118,0,1276,12,
1,18699,1277,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,1278,12,
1,18746,1279,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
1280,12,1,18791,1281,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,1282,12,
1,18826,1283,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,1284,12,1,18856,
1285,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,1286,12,1,18889,
1287,5,63,3,109,
0,327,3,110,0,
327,3,111,0,327,
3,112,0,327,3,
113,0,327,3,114,
0,327,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1288,11,1,320,0,
1289,4,22,86,0,
69,0,67,0,84,
0,79,0,82,0,
95,0,84,0,89,
0,80,0,69,0,
1,-1,3,115,0,
327,3,116,0,327,
3,117,0,327,3,
118,0,327,3,119,
0,327,3,120,0,
327,3,121,0,327,
3,122,0,327,3,
48,0,327,3,49,
0,327,3,50,0,
327,3,51,0,327,
3,52,0,327,3,
53,0,327,3,54,
0,327,3,55,0,
327,3,56,0,327,
3,57,0,327,3,
65,0,327,3,66,
0,327,3,67,0,
327,3,68,0,327,
3,69,0,327,3,
70,0,327,3,71,
0,327,3,72,0,
327,3,73,0,327,
3,74,0,327,3,
75,0,327,3,76,
0,327,3,77,0,
327,3,78,0,327,
3,79,0,327,3,
80,0,327,3,81,
0,327,3,82,0,
327,3,83,0,327,
3,84,0,327,3,
85,0,327,3,86,
0,327,3,87,0,
327,3,88,0,327,
3,89,0,327,3,
90,0,327,3,95,
0,327,3,97,0,
327,3,98,0,327,
3,99,0,327,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1290,11,1,829,0,
330,1,-1,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
327,3,106,0,327,
3,107,0,327,3,
108,0,327,1291,11,
1,829,0,330,1,
-1,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1292,11,1,829,
0,330,1,-1,3,
100,0,327,3,101,
0,327,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1293,11,1,829,0,
330,1,-1,3,102,
0,327,3,103,0,
327,3,104,0,327,
3,105,0,327,3,
106,0,327,3,107,
0,327,3,108,0,
327,1294,11,1,829,
0,330,1,-1,3,
119,0,1295,12,1,
19420,1296,5,63,3,
109,0,327,3,110,
0,327,3,111,0,
327,3,112,0,327,
3,113,0,327,3,
114,0,327,3,115,
0,327,3,116,0,
327,3,117,0,327,
3,118,0,327,3,
119,0,327,3,120,
0,327,3,121,0,
327,3,122,0,327,
3,48,0,327,3,
49,0,327,3,50,
0,327,3,51,0,
327,3,52,0,327,
3,53,0,327,3,
54,0,327,3,55,
0,327,3,56,0,
327,3,57,0,327,
3,65,0,327,3,
66,0,327,3,67,
0,327,3,68,0,
327,3,69,0,327,
3,70,0,327,3,
71,0,327,3,72,
0,327,3,73,0,
327,3,74,0,327,
3,75,0,327,3,
76,0,327,3,77,
0,327,3,78,0,
327,3,79,0,327,
3,80,0,327,3,
81,0,327,3,82,
0,327,3,83,0,
327,3,84,0,327,
3,85,0,327,3,
86,0,327,3,87,
0,327,3,88,0,
327,3,89,0,327,
3,90,0,327,3,
95,0,327,3,97,
0,327,3,98,0,
327,3,99,0,327,
3,100,0,327,3,
101,0,327,3,102,
0,327,3,103,0,
327,3,104,0,1297,
12,1,19470,1298,5,
63,3,109,0,327,
3,110,0,327,3,
111,0,327,3,112,
0,327,3,113,0,
327,3,114,0,327,
3,115,0,327,3,
116,0,327,3,117,
0,327,3,118,0,
327,3,119,0,327,
3,120,0,327,3,
121,0,327,3,122,
0,327,3,48,0,
327,3,49,0,327,
3,50,0,327,3,
51,0,327,3,52,
0,327,3,53,0,
327,3,54,0,327,
3,55,0,327,3,
56,0,327,3,57,
0,327,3,65,0,
327,3,66,0,327,
3,67,0,327,3,
68,0,327,3,69,
0,327,3,70,0,
327,3,71,0,327,
3,72,0,327,3,
73,0,327,3,74,
0,327,3,75,0,
327,3,76,0,327,
3,77,0,327,3,
78,0,327,3,79,
0,327,3,80,0,
327,3,81,0,327,
3,82,0,327,3,
83,0,327,3,84,
0,327,3,85,0,
327,3,86,0,327,
3,87,0,327,3,
88,0,327,3,89,
0,327,3,90,0,
327,3,95,0,327,
3,97,0,327,3,
98,0,327,3,99,
0,327,3,100,0,
327,3,101,0,327,
3,102,0,327,3,
103,0,327,3,104,
0,327,3,105,0,
1299,12,1,19521,1300,
5,63,3,109,0,
327,3,110,0,327,
3,111,0,327,3,
112,0,327,3,113,
0,327,3,114,0,
327,3,115,0,327,
3,116,0,327,3,
117,0,327,3,118,
0,327,3,119,0,
327,3,120,0,327,
3,121,0,327,3,
122,0,327,3,48,
0,327,3,49,0,
327,3,50,0,327,
3,51,0,327,3,
52,0,327,3,53,
0,327,3,54,0,
327,3,55,0,327,
3,56,0,327,3,
57,0,327,3,65,
0,327,3,66,0,
327,3,67,0,327,
3,68,0,327,3,
69,0,327,3,70,
0,327,3,71,0,
327,3,72,0,327,
3,73,0,327,3,
74,0,327,3,75,
0,327,3,76,0,
327,3,77,0,327,
3,78,0,327,3,
79,0,327,3,80,
0,327,3,81,0,
327,3,82,0,327,
3,83,0,327,3,
84,0,327,3,85,
0,327,3,86,0,
327,3,87,0,327,
3,88,0,327,3,
89,0,327,3,90,
0,327,3,95,0,
327,3,97,0,327,
3,98,0,327,3,
99,0,327,3,100,
0,327,3,101,0,
327,3,102,0,327,
3,103,0,327,3,
104,0,327,3,105,
0,327,3,106,0,
327,3,107,0,327,
3,108,0,1301,12,
1,19575,1302,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,1303,12,
1,19622,1304,5,63,
3,109,0,327,3,
110,0,327,3,111,
0,327,3,112,0,
327,3,113,0,327,
3,114,0,327,3,
115,0,327,3,116,
0,327,3,117,0,
327,3,118,0,327,
3,119,0,327,3,
120,0,327,3,121,
0,327,3,122,0,
327,3,48,0,327,
3,49,0,327,3,
50,0,327,3,51,
0,327,3,52,0,
327,3,53,0,327,
3,54,0,327,3,
55,0,327,3,56,
0,327,3,57,0,
327,3,65,0,327,
3,66,0,327,3,
67,0,327,3,68,
0,327,3,69,0,
327,3,70,0,327,
3,71,0,327,3,
72,0,327,3,73,
0,327,3,74,0,
327,3,75,0,327,
3,76,0,327,3,
77,0,327,3,78,
0,327,3,79,0,
327,3,80,0,327,
3,81,0,327,3,
82,0,327,3,83,
0,327,3,84,0,
327,3,85,0,327,
3,86,0,327,3,
87,0,327,3,88,
0,327,3,89,0,
327,3,90,0,327,
3,95,0,327,3,
97,0,327,3,98,
0,327,3,99,0,
327,3,100,0,327,
3,101,0,327,3,
102,0,327,3,103,
0,327,3,104,0,
327,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1305,11,1,
229,0,1306,4,10,
87,0,72,0,73,
0,76,0,69,0,
1,-1,3,102,0,
327,3,103,0,327,
3,104,0,327,3,
105,0,327,3,106,
0,327,3,107,0,
327,3,108,0,327,
1307,11,1,829,0,
330,1,-1,1308,11,
1,829,0,330,1,
-1,3,106,0,327,
3,107,0,327,3,
108,0,327,1309,11,
1,829,0,330,1,
-1,3,105,0,327,
3,106,0,327,3,
107,0,327,3,108,
0,327,1310,11,1,
829,0,330,1,-1,
3,120,0,325,3,
121,0,325,3,122,
0,325,3,123,0,
1311,12,1,39751,1312,
5,0,1313,11,1,
51,0,1314,4,20,
76,0,69,0,70,
0,84,0,95,0,
66,0,82,0,65,
0,67,0,69,0,
1,-1,3,124,0,
1315,12,1,42534,1316,
5,1,3,124,0,
1317,12,1,42646,1318,
5,0,1319,11,1,
191,0,1320,4,26,
83,0,84,0,82,
0,79,0,75,0,
69,0,95,0,83,
0,84,0,82,0,
79,0,75,0,69,
0,1,-1,1321,11,
1,165,0,1322,4,
12,83,0,84,0,
82,0,79,0,75,
0,69,0,1,-1,
3,125,0,1323,12,
1,40116,1324,5,0,
1325,11,1,56,0,
1326,4,22,82,0,
73,0,71,0,72,
0,84,0,95,0,
66,0,82,0,65,
0,67,0,69,0,
1,-1,3,126,0,
1327,12,1,42775,1328,
5,0,1329,11,1,
175,0,1330,4,10,
84,0,73,0,76,
0,68,0,69,0,
1,-1,0,165,1,
-1,1331,4,12,83,
0,84,0,82,0,
73,0,78,0,71,
0,1332,12,1,44343,
1333,5,119,3,1,
0,1334,12,1,44344,
1335,5,0,1336,11,
1,930,0,165,1,
-1,3,9,0,1334,
3,10,0,1337,12,
1,44545,1338,5,0,
1339,11,1,936,0,
165,1,-1,3,13,
0,1334,3,0,3,
1334,3,96,33,1334,
3,32,0,1334,3,
33,0,1334,3,34,
0,1340,12,1,45292,
1341,5,0,1342,11,
1,994,0,165,1,
-1,3,35,0,1334,
3,36,0,1334,3,
37,0,1334,3,38,
0,1334,3,40,0,
1334,3,41,0,1334,
3,42,0,1334,3,
43,0,1334,3,44,
0,1334,3,45,0,
1334,3,46,0,1334,
3,47,0,1334,3,
3,9,1334,3,49,
0,1334,3,50,0,
1334,3,48,0,1334,
3,52,0,1334,3,
53,0,1334,3,51,
0,1334,3,55,0,
1334,3,56,0,1334,
3,54,0,1334,3,
59,0,1334,3,57,
0,1334,3,61,0,
1334,3,62,0,1334,
3,60,0,1334,3,
64,0,1334,3,65,
0,1334,3,66,0,
1334,3,67,0,1334,
3,68,0,1334,3,
69,0,1334,3,70,
0,1334,3,71,0,
1334,3,72,0,1334,
3,73,0,1334,3,
74,0,1334,3,75,
0,1334,3,76,0,
1334,3,77,0,1334,
3,78,0,1334,3,
79,0,1334,3,80,
0,1334,3,81,0,
1334,3,82,0,1334,
3,83,0,1334,3,
84,0,1334,3,85,
0,1334,3,86,0,
1334,3,87,0,1334,
3,88,0,1334,3,
89,0,1334,3,90,
0,1334,3,91,0,
1334,3,92,0,1343,
12,1,44688,1344,5,
4,3,110,0,1345,
12,1,44717,1346,5,
0,1347,11,1,941,
0,165,1,-1,3,
34,0,1348,12,1,
45157,1349,5,0,1350,
11,1,965,0,165,
1,-1,3,92,0,
1351,12,1,45033,1352,
5,0,1353,11,1,
977,0,165,1,-1,
3,116,0,1354,12,
1,44843,1355,5,0,
1356,11,1,953,0,
165,1,-1,1357,11,
1,989,0,165,1,
-1,3,93,0,1334,
3,94,0,1334,3,
95,0,1334,3,96,
0,1334,3,97,0,
1334,3,98,0,1334,
3,99,0,1334,3,
100,0,1334,3,101,
0,1334,3,102,0,
1334,3,103,0,1334,
3,104,0,1334,3,
105,0,1334,3,106,
0,1334,3,107,0,
1334,3,108,0,1334,
3,109,0,1334,3,
110,0,1334,3,111,
0,1334,3,112,0,
1334,3,113,0,1334,
3,114,0,1334,3,
115,0,1334,3,116,
0,1334,3,117,0,
1334,3,118,0,1334,
3,119,0,1334,3,
120,0,1334,3,121,
0,1334,3,122,0,
1334,3,123,0,1334,
3,124,0,1334,3,
125,0,1334,3,96,
6,1334,3,126,0,
1334,3,58,15,1334,
3,59,15,1334,3,
136,4,1334,3,160,
0,1334,3,15,7,
1334,3,170,0,1334,
3,171,0,1334,3,
172,0,1334,3,173,
0,1334,3,178,0,
1334,3,176,2,1334,
3,187,0,1334,3,
187,1,1334,3,192,
0,1334,3,41,32,
1334,3,197,1,1334,
3,0,224,1334,3,
40,32,1334,3,63,
32,1334,0,165,1,
-1,1358,5,92,236,
1359,10,236,1,19,
555,1360,10,555,1,
47,283,1361,10,283,
1,92,1138,1362,10,
1138,1,50,1007,1363,
10,1007,1,80,1157,
1364,10,1157,1,53,
173,1365,10,173,1,
37,584,1366,10,584,
1,43,666,1367,10,
666,1,51,595,1368,
10,595,1,46,196,
1369,10,196,1,16,
200,1370,10,200,1,
17,638,1371,10,638,
1,68,867,1372,10,
867,1,75,343,1373,
10,343,1,35,208,
1374,10,208,1,20,
214,1375,10,214,1,
6,184,1376,10,184,
1,22,268,1377,10,
268,1,21,250,1378,
10,250,1,94,1258,
1379,10,1258,1,88,
463,1380,10,463,1,
64,686,1381,10,686,
1,49,339,1382,10,
339,1,28,300,1383,
10,300,1,25,675,
1384,10,675,1,42,
758,1385,10,758,1,
69,1197,1386,10,1197,
1,48,318,1387,10,
318,1,41,816,1388,
10,816,1,57,218,
1389,10,218,1,4,
324,1390,10,324,1,
23,475,1391,10,475,
1,63,1212,1392,10,
1212,1,84,306,1393,
10,306,1,29,230,
1394,10,230,1,5,
298,1395,10,298,1,
31,606,1396,10,606,
1,52,855,1397,10,
855,1,76,1080,1398,
10,1080,1,83,983,
1399,10,983,1,81,
961,1400,10,961,1,
77,171,1401,10,171,
1,30,234,1402,10,
234,1,7,813,1403,
10,813,1,73,182,
1404,10,182,1,10,
335,1405,10,335,1,
27,276,1406,10,276,
1,93,224,1407,10,
224,1,14,254,1408,
10,254,1,24,697,
1409,10,697,1,54,
266,1410,10,266,1,
9,1191,1411,10,1191,
1,86,480,1412,10,
480,1,62,1413,4,
30,83,0,84,0,
82,0,73,0,78,
0,71,0,95,0,
67,0,79,0,78,
0,83,0,84,0,
65,0,78,0,84,
0,1414,10,1413,1,
3,1306,1415,10,1306,
1,45,330,1416,10,
330,1,91,533,1417,
10,533,1,66,1034,
1418,10,1034,1,56,
384,1419,10,384,1,
58,1314,1420,10,1314,
1,12,513,1421,10,
513,1,44,294,1422,
10,294,1,40,1120,
1423,10,1120,1,82,
573,1424,10,573,1,
67,912,1425,10,912,
1,78,1330,1426,10,
1330,1,36,1322,1427,
10,1322,1,34,753,
1428,10,753,1,70,
1271,1429,10,1271,1,
87,831,1430,10,831,
1,74,320,1431,10,
320,1,26,407,1432,
10,407,1,59,192,
1433,10,192,1,33,
288,1434,10,288,1,
11,190,1435,10,190,
1,38,501,1436,10,
501,1,61,794,1437,
10,794,1,72,1253,
1438,10,1253,1,90,
308,1439,10,308,1,
15,935,1440,10,935,
1,79,1320,1441,10,
1320,1,39,314,1442,
10,314,1,32,1241,
1443,10,1241,1,89,
357,1444,10,357,1,
60,1289,1445,10,1289,
1,55,1326,1446,10,
1326,1,13,1180,1447,
10,1180,1,85,220,
1448,10,220,1,18,
206,1449,10,206,1,
8,741,1450,10,741,
1,71,431,1451,10,
431,1,65,1452,5,
0,0};
 new Tfactory(this,"MINUS",new TCreator(MINUS_factory));
 new Tfactory(this,"DEFAULT_STATE",new TCreator(DEFAULT_STATE_factory));
 new Tfactory(this,"INTEGER_CONSTANT",new TCreator(INTEGER_CONSTANT_factory));
 new Tfactory(this,"RETURN",new TCreator(RETURN_factory));
 new Tfactory(this,"OBJECT_REZ_EVENT",new TCreator(OBJECT_REZ_EVENT_factory));
 new Tfactory(this,"STRING_TYPE",new TCreator(STRING_TYPE_factory));
 new Tfactory(this,"EXCLAMATION",new TCreator(EXCLAMATION_factory));
 new Tfactory(this,"ELSE",new TCreator(ELSE_factory));
 new Tfactory(this,"INTEGER_TYPE",new TCreator(INTEGER_TYPE_factory));
 new Tfactory(this,"FOR",new TCreator(FOR_factory));
 new Tfactory(this,"LEFT_PAREN",new TCreator(LEFT_PAREN_factory));
 new Tfactory(this,"RIGHT_PAREN",new TCreator(RIGHT_PAREN_factory));
 new Tfactory(this,"HTTP_RESPONSE_EVENT",new TCreator(HTTP_RESPONSE_EVENT_factory));
 new Tfactory(this,"MOVING_END_EVENT",new TCreator(MOVING_END_EVENT_factory));
 new Tfactory(this,"CARET",new TCreator(CARET_factory));
 new Tfactory(this,"STAR",new TCreator(STAR_factory));
 new Tfactory(this,"PLUS_EQUALS",new TCreator(PLUS_EQUALS_factory));
 new Tfactory(this,"PERCENT",new TCreator(PERCENT_factory));
 new Tfactory(this,"SLASH",new TCreator(SLASH_factory));
 new Tfactory(this,"FLOAT_CONSTANT",new TCreator(FLOAT_CONSTANT_factory));
 new Tfactory(this,"TOUCH_EVENT",new TCreator(TOUCH_EVENT_factory));
 new Tfactory(this,"COLLISION_START_EVENT",new TCreator(COLLISION_START_EVENT_factory));
 new Tfactory(this,"JUMP",new TCreator(JUMP_factory));
 new Tfactory(this,"RIGHT_BRACKET",new TCreator(RIGHT_BRACKET_factory));
 new Tfactory(this,"LEFT_ANGLE",new TCreator(LEFT_ANGLE_factory));
 new Tfactory(this,"IF",new TCreator(IF_factory));
 new Tfactory(this,"LAND_COLLISION_EVENT",new TCreator(LAND_COLLISION_EVENT_factory));
 new Tfactory(this,"STATE",new TCreator(STATE_factory));
 new Tfactory(this,"RIGHT_SHIFT",new TCreator(RIGHT_SHIFT_factory));
 new Tfactory(this,"LIST_TYPE",new TCreator(LIST_TYPE_factory));
 new Tfactory(this,"INCREMENT",new TCreator(INCREMENT_factory));
 new Tfactory(this,"AT",new TCreator(AT_factory));
 new Tfactory(this,"COLLISION_END_EVENT",new TCreator(COLLISION_END_EVENT_factory));
 new Tfactory(this,"SENSOR_EVENT",new TCreator(SENSOR_EVENT_factory));
 new Tfactory(this,"EQUALS_EQUALS",new TCreator(EQUALS_EQUALS_factory));
 new Tfactory(this,"DECREMENT",new TCreator(DECREMENT_factory));
 new Tfactory(this,"LESS_EQUALS",new TCreator(LESS_EQUALS_factory));
 new Tfactory(this,"FLOAT_TYPE",new TCreator(FLOAT_TYPE_factory));
 new Tfactory(this,"MOVING_START_EVENT",new TCreator(MOVING_START_EVENT_factory));
 new Tfactory(this,"RUN_TIME_PERMISSIONS_EVENT",new TCreator(RUN_TIME_PERMISSIONS_EVENT_factory));
 new Tfactory(this,"ON_REZ_EVENT",new TCreator(ON_REZ_EVENT_factory));
 new Tfactory(this,"NO_SENSOR_EVENT",new TCreator(NO_SENSOR_EVENT_factory));
 new Tfactory(this,"EXCLAMATION_EQUALS",new TCreator(EXCLAMATION_EQUALS_factory));
 new Tfactory(this,"MINUS_EQUALS",new TCreator(MINUS_EQUALS_factory));
 new Tfactory(this,"LISTEN_EVENT",new TCreator(LISTEN_EVENT_factory));
 new Tfactory(this,"PERCENT_EQUALS",new TCreator(PERCENT_EQUALS_factory));
 new Tfactory(this,"LEFT_BRACKET",new TCreator(LEFT_BRACKET_factory));
 new Tfactory(this,"HEX_INTEGER_CONSTANT",new TCreator(HEX_INTEGER_CONSTANT_factory));
 new Tfactory(this,"COMMA",new TCreator(COMMA_factory));
 new Tfactory(this,"PERIOD",new TCreator(PERIOD_factory));
 new Tfactory(this,"KEY_TYPE",new TCreator(KEY_TYPE_factory));
 new Tfactory(this,"SLASH_EQUALS",new TCreator(SLASH_EQUALS_factory));
 new Tfactory(this,"STATE_EXIT_EVENT",new TCreator(STATE_EXIT_EVENT_factory));
 new Tfactory(this,"COLLISION_EVENT",new TCreator(COLLISION_EVENT_factory));
 new Tfactory(this,"STRING_CONSTANT",new TCreator(STRING_CONSTANT_factory));
 new Tfactory(this,"WHILE",new TCreator(WHILE_factory));
 new Tfactory(this,"IDENT",new TCreator(IDENT_factory));
 new Tfactory(this,"DATASERVER_EVENT",new TCreator(DATASERVER_EVENT_factory));
 new Tfactory(this,"ROTATION_TYPE",new TCreator(ROTATION_TYPE_factory));
 new Tfactory(this,"AT_ROT_TARGET_EVENT",new TCreator(AT_ROT_TARGET_EVENT_factory));
 new Tfactory(this,"LEFT_BRACE",new TCreator(LEFT_BRACE_factory));
 new Tfactory(this,"DO",new TCreator(DO_factory));
 new Tfactory(this,"LEFT_SHIFT",new TCreator(LEFT_SHIFT_factory));
 new Tfactory(this,"REMOTE_DATA_EVENT",new TCreator(REMOTE_DATA_EVENT_factory));
 new Tfactory(this,"EMAIL_EVENT",new TCreator(EMAIL_EVENT_factory));
 new Tfactory(this,"NOT_AT_ROT_TARGET_EVENT",new TCreator(NOT_AT_ROT_TARGET_EVENT_factory));
 new Tfactory(this,"TILDE",new TCreator(TILDE_factory));
 new Tfactory(this,"STROKE",new TCreator(STROKE_factory));
 new Tfactory(this,"LAND_COLLISION_END_EVENT",new TCreator(LAND_COLLISION_END_EVENT_factory));
 new Tfactory(this,"TIMER_EVENT",new TCreator(TIMER_EVENT_factory));
 new Tfactory(this,"MONEY_EVENT",new TCreator(MONEY_EVENT_factory));
 new Tfactory(this,"RIGHT_ANGLE",new TCreator(RIGHT_ANGLE_factory));
 new Tfactory(this,"AT_TARGET_EVENT",new TCreator(AT_TARGET_EVENT_factory));
 new Tfactory(this,"AMP",new TCreator(AMP_factory));
 new Tfactory(this,"SEMICOLON",new TCreator(SEMICOLON_factory));
 new Tfactory(this,"AMP_AMP",new TCreator(AMP_AMP_factory));
 new Tfactory(this,"CHANGED_EVENT",new TCreator(CHANGED_EVENT_factory));
 new Tfactory(this,"LINK_MESSAGE_EVENT",new TCreator(LINK_MESSAGE_EVENT_factory));
 new Tfactory(this,"TOUCH_END_EVENT",new TCreator(TOUCH_END_EVENT_factory));
 new Tfactory(this,"EQUALS",new TCreator(EQUALS_factory));
 new Tfactory(this,"NOT_AT_TARGET_EVENT",new TCreator(NOT_AT_TARGET_EVENT_factory));
 new Tfactory(this,"STROKE_STROKE",new TCreator(STROKE_STROKE_factory));
 new Tfactory(this,"GREATER_EQUALS",new TCreator(GREATER_EQUALS_factory));
 new Tfactory(this,"TOUCH_START_EVENT",new TCreator(TOUCH_START_EVENT_factory));
 new Tfactory(this,"ATTACH_EVENT",new TCreator(ATTACH_EVENT_factory));
 new Tfactory(this,"VECTOR_TYPE",new TCreator(VECTOR_TYPE_factory));
 new Tfactory(this,"RIGHT_BRACE",new TCreator(RIGHT_BRACE_factory));
 new Tfactory(this,"STATE_ENTRY_EVENT",new TCreator(STATE_ENTRY_EVENT_factory));
 new Tfactory(this,"PLUS",new TCreator(PLUS_factory));
 new Tfactory(this,"STAR_EQUALS",new TCreator(STAR_EQUALS_factory));
 new Tfactory(this,"LAND_COLLISION_START_EVENT",new TCreator(LAND_COLLISION_START_EVENT_factory));
 new Tfactory(this,"CONTROL_EVENT",new TCreator(CONTROL_EVENT_factory));
}
public static object MINUS_factory(Lexer yyl) { return new MINUS(yyl);}
public static object DEFAULT_STATE_factory(Lexer yyl) { return new DEFAULT_STATE(yyl);}
public static object INTEGER_CONSTANT_factory(Lexer yyl) { return new INTEGER_CONSTANT(yyl);}
public static object RETURN_factory(Lexer yyl) { return new RETURN(yyl);}
public static object OBJECT_REZ_EVENT_factory(Lexer yyl) { return new OBJECT_REZ_EVENT(yyl);}
public static object STRING_TYPE_factory(Lexer yyl) { return new STRING_TYPE(yyl);}
public static object EXCLAMATION_factory(Lexer yyl) { return new EXCLAMATION(yyl);}
public static object ELSE_factory(Lexer yyl) { return new ELSE(yyl);}
public static object INTEGER_TYPE_factory(Lexer yyl) { return new INTEGER_TYPE(yyl);}
public static object FOR_factory(Lexer yyl) { return new FOR(yyl);}
public static object LEFT_PAREN_factory(Lexer yyl) { return new LEFT_PAREN(yyl);}
public static object RIGHT_PAREN_factory(Lexer yyl) { return new RIGHT_PAREN(yyl);}
public static object HTTP_RESPONSE_EVENT_factory(Lexer yyl) { return new HTTP_RESPONSE_EVENT(yyl);}
public static object MOVING_END_EVENT_factory(Lexer yyl) { return new MOVING_END_EVENT(yyl);}
public static object CARET_factory(Lexer yyl) { return new CARET(yyl);}
public static object STAR_factory(Lexer yyl) { return new STAR(yyl);}
public static object PLUS_EQUALS_factory(Lexer yyl) { return new PLUS_EQUALS(yyl);}
public static object PERCENT_factory(Lexer yyl) { return new PERCENT(yyl);}
public static object SLASH_factory(Lexer yyl) { return new SLASH(yyl);}
public static object FLOAT_CONSTANT_factory(Lexer yyl) { return new FLOAT_CONSTANT(yyl);}
public static object TOUCH_EVENT_factory(Lexer yyl) { return new TOUCH_EVENT(yyl);}
public static object COLLISION_START_EVENT_factory(Lexer yyl) { return new COLLISION_START_EVENT(yyl);}
public static object JUMP_factory(Lexer yyl) { return new JUMP(yyl);}
public static object RIGHT_BRACKET_factory(Lexer yyl) { return new RIGHT_BRACKET(yyl);}
public static object LEFT_ANGLE_factory(Lexer yyl) { return new LEFT_ANGLE(yyl);}
public static object IF_factory(Lexer yyl) { return new IF(yyl);}
public static object LAND_COLLISION_EVENT_factory(Lexer yyl) { return new LAND_COLLISION_EVENT(yyl);}
public static object STATE_factory(Lexer yyl) { return new STATE(yyl);}
public static object RIGHT_SHIFT_factory(Lexer yyl) { return new RIGHT_SHIFT(yyl);}
public static object LIST_TYPE_factory(Lexer yyl) { return new LIST_TYPE(yyl);}
public static object INCREMENT_factory(Lexer yyl) { return new INCREMENT(yyl);}
public static object AT_factory(Lexer yyl) { return new AT(yyl);}
public static object COLLISION_END_EVENT_factory(Lexer yyl) { return new COLLISION_END_EVENT(yyl);}
public static object SENSOR_EVENT_factory(Lexer yyl) { return new SENSOR_EVENT(yyl);}
public static object EQUALS_EQUALS_factory(Lexer yyl) { return new EQUALS_EQUALS(yyl);}
public static object DECREMENT_factory(Lexer yyl) { return new DECREMENT(yyl);}
public static object LESS_EQUALS_factory(Lexer yyl) { return new LESS_EQUALS(yyl);}
public static object FLOAT_TYPE_factory(Lexer yyl) { return new FLOAT_TYPE(yyl);}
public static object MOVING_START_EVENT_factory(Lexer yyl) { return new MOVING_START_EVENT(yyl);}
public static object RUN_TIME_PERMISSIONS_EVENT_factory(Lexer yyl) { return new RUN_TIME_PERMISSIONS_EVENT(yyl);}
public static object ON_REZ_EVENT_factory(Lexer yyl) { return new ON_REZ_EVENT(yyl);}
public static object NO_SENSOR_EVENT_factory(Lexer yyl) { return new NO_SENSOR_EVENT(yyl);}
public static object EXCLAMATION_EQUALS_factory(Lexer yyl) { return new EXCLAMATION_EQUALS(yyl);}
public static object MINUS_EQUALS_factory(Lexer yyl) { return new MINUS_EQUALS(yyl);}
public static object LISTEN_EVENT_factory(Lexer yyl) { return new LISTEN_EVENT(yyl);}
public static object PERCENT_EQUALS_factory(Lexer yyl) { return new PERCENT_EQUALS(yyl);}
public static object LEFT_BRACKET_factory(Lexer yyl) { return new LEFT_BRACKET(yyl);}
public static object HEX_INTEGER_CONSTANT_factory(Lexer yyl) { return new HEX_INTEGER_CONSTANT(yyl);}
public static object COMMA_factory(Lexer yyl) { return new COMMA(yyl);}
public static object PERIOD_factory(Lexer yyl) { return new PERIOD(yyl);}
public static object KEY_TYPE_factory(Lexer yyl) { return new KEY_TYPE(yyl);}
public static object SLASH_EQUALS_factory(Lexer yyl) { return new SLASH_EQUALS(yyl);}
public static object STATE_EXIT_EVENT_factory(Lexer yyl) { return new STATE_EXIT_EVENT(yyl);}
public static object COLLISION_EVENT_factory(Lexer yyl) { return new COLLISION_EVENT(yyl);}
public static object STRING_CONSTANT_factory(Lexer yyl) { return new STRING_CONSTANT(yyl);}
public static object WHILE_factory(Lexer yyl) { return new WHILE(yyl);}
public static object IDENT_factory(Lexer yyl) { return new IDENT(yyl);}
public static object DATASERVER_EVENT_factory(Lexer yyl) { return new DATASERVER_EVENT(yyl);}
public static object ROTATION_TYPE_factory(Lexer yyl) { return new ROTATION_TYPE(yyl);}
public static object AT_ROT_TARGET_EVENT_factory(Lexer yyl) { return new AT_ROT_TARGET_EVENT(yyl);}
public static object LEFT_BRACE_factory(Lexer yyl) { return new LEFT_BRACE(yyl);}
public static object DO_factory(Lexer yyl) { return new DO(yyl);}
public static object LEFT_SHIFT_factory(Lexer yyl) { return new LEFT_SHIFT(yyl);}
public static object REMOTE_DATA_EVENT_factory(Lexer yyl) { return new REMOTE_DATA_EVENT(yyl);}
public static object EMAIL_EVENT_factory(Lexer yyl) { return new EMAIL_EVENT(yyl);}
public static object NOT_AT_ROT_TARGET_EVENT_factory(Lexer yyl) { return new NOT_AT_ROT_TARGET_EVENT(yyl);}
public static object TILDE_factory(Lexer yyl) { return new TILDE(yyl);}
public static object STROKE_factory(Lexer yyl) { return new STROKE(yyl);}
public static object LAND_COLLISION_END_EVENT_factory(Lexer yyl) { return new LAND_COLLISION_END_EVENT(yyl);}
public static object TIMER_EVENT_factory(Lexer yyl) { return new TIMER_EVENT(yyl);}
public static object MONEY_EVENT_factory(Lexer yyl) { return new MONEY_EVENT(yyl);}
public static object RIGHT_ANGLE_factory(Lexer yyl) { return new RIGHT_ANGLE(yyl);}
public static object AT_TARGET_EVENT_factory(Lexer yyl) { return new AT_TARGET_EVENT(yyl);}
public static object AMP_factory(Lexer yyl) { return new AMP(yyl);}
public static object SEMICOLON_factory(Lexer yyl) { return new SEMICOLON(yyl);}
public static object AMP_AMP_factory(Lexer yyl) { return new AMP_AMP(yyl);}
public static object CHANGED_EVENT_factory(Lexer yyl) { return new CHANGED_EVENT(yyl);}
public static object LINK_MESSAGE_EVENT_factory(Lexer yyl) { return new LINK_MESSAGE_EVENT(yyl);}
public static object TOUCH_END_EVENT_factory(Lexer yyl) { return new TOUCH_END_EVENT(yyl);}
public static object EQUALS_factory(Lexer yyl) { return new EQUALS(yyl);}
public static object NOT_AT_TARGET_EVENT_factory(Lexer yyl) { return new NOT_AT_TARGET_EVENT(yyl);}
public static object STROKE_STROKE_factory(Lexer yyl) { return new STROKE_STROKE(yyl);}
public static object GREATER_EQUALS_factory(Lexer yyl) { return new GREATER_EQUALS(yyl);}
public static object TOUCH_START_EVENT_factory(Lexer yyl) { return new TOUCH_START_EVENT(yyl);}
public static object ATTACH_EVENT_factory(Lexer yyl) { return new ATTACH_EVENT(yyl);}
public static object VECTOR_TYPE_factory(Lexer yyl) { return new VECTOR_TYPE(yyl);}
public static object RIGHT_BRACE_factory(Lexer yyl) { return new RIGHT_BRACE(yyl);}
public static object STATE_ENTRY_EVENT_factory(Lexer yyl) { return new STATE_ENTRY_EVENT(yyl);}
public static object PLUS_factory(Lexer yyl) { return new PLUS(yyl);}
public static object STAR_EQUALS_factory(Lexer yyl) { return new STAR_EQUALS(yyl);}
public static object LAND_COLLISION_START_EVENT_factory(Lexer yyl) { return new LAND_COLLISION_START_EVENT(yyl);}
public static object CONTROL_EVENT_factory(Lexer yyl) { return new CONTROL_EVENT(yyl);}
public override TOKEN OldAction(Lexer yym,ref string yytext,int action, ref bool reject) {
  switch(action) {
  case -1: break;
   case 977: { ((LSLTokens)yym).str += "\\\\"; }
      break;
   case 1003: ;   
      break;
   case 925: { yym.yy_begin("STRING"); ((LSLTokens)yym).str = "";}
      break;
   case 930: { ((LSLTokens)yym).str += yytext; }
      break;
   case 936: { ((LSLTokens)yym).str += "\\n"; }
      break;
   case 941: { ((LSLTokens)yym).str += "\\n"; }
      break;
   case 953: { ((LSLTokens)yym).str += "    "; }
      break;
   case 965: { ((LSLTokens)yym).str += "\\\""; }
      break;
   case 989: { ((LSLTokens)yym).str += '\\'; }
      break;
   case 994: { yym.yy_begin("YYINITIAL"); ((LSLTokens)yym).yytext = ((LSLTokens)yym).str; ((LSLTokens)yym).str = String.Empty; return new STRING_CONSTANT(yym); }
   case 999: ;   
      break;
  }
  return null;
}}
public class LSLTokens:Lexer {
public LSLTokens():base(new yyLSLTokens(new ErrorHandler(false))) {}
public LSLTokens(ErrorHandler eh):base(new yyLSLTokens(eh)) {}
public LSLTokens(YyLexer tks):base(tks){}

    public string str;

 }
}
